<?php
/**
 * Created by PhpStorm.
 * User: HP
 * Date: 2021/11/8
 * Time: 16:06
 */

namespace app\admin\controller;
use PhpOffice\PhpSpreadsheet\Reader\Xls\MD5;
use think\facade\Cookie;
use think\facade\Db;
use think\facade\Session;
use app\admin\model\Admin as Adminmodel;
use think\facade\View;
class Admin extends Common
{
//首页加载
    public function index(){

        return View::fetch('index');
    }

    public function setsort(){
    
        $admin=Db::name('admin')->withAttr('create_time', function ($value) {
            return date('Y-m-d', $value);
        })->withAttr('last_time', function ($value) {
            return date('Y-m-d', $value);
        })->order('id desc')->select()->toArray();

        foreach ($admin as $k=>$v){

            $auth_group=  Db::name('auth_group')->where('id','=',$v['groupid'])->find();

            $title=$auth_group['title'];
            $admin[$k]['title'][]=$title;

        }

        $currpage =page_array($admin, 15, 10);

        $data = [
            'msg'=>'OK',
            "status" => '200',
            "hint" => "无数据",
            "total" => count($admin),
            "rows" => $currpage['data']
        ];
        return json($data);
    }

//添加新数据
    public function add(){
        if (request()->isPost()){
            $data=input('post.');
            $add=AdminModel::getadd($data);
            return $add;
        }
        //所属用户组
        $admin=Db::name('admin')->where('id','=',Cookie('uid'))->field('groupid')->find();
        $groupRes=Db::name('authGroup')->select();
        View::assign([
            'groupRes'=>$groupRes,
            'groupid'=>$admin['groupid'],
            'uname'=>Cookie('uname')
        ]);
        return View::fetch('add');
    }



    //删除用户
    public function del($id)
    {

        if($id==1){
            return json(['code'=>0,"msg"=>'超级管理员不允许删除']);
        }

        $del=Db::name('admin')->delete($id);
        $delAccess=Db::name('auth_group_access')->where(array('uid'=>$id))->delete();
        if($del){
            return json(['code'=>1,"msg"=>'删除管理员成功']);
        }else{
            return json(['code'=>1,"msg"=>'删除管理员失败!']);
        }
    }

    /**
     * 显示编辑资源表单页.
     *
     * @param  int  $id
     * @return \think\Response
     */
    public function edit(){

        if(request()->isPost()){
            $data=input('post.');
            //验证
            $save=AdminModel::getedit($data);
            return $save;
        }
        $admins=Db::name('admin')->field('id,uname,groupid')->find(input('id'));
        //所属用户组
        $groupRes=Db::name('authGroup')->select();
        View::assign([
            'admins'=>$admins,
            'groupRes'=>$groupRes,
            'uname'=>Cookie('uname')

        ]);
        return View::fetch('edit');
    }
    //退出登录
    public function logout(){
//        Session::clear();
     
        cookie('uname', null);;
        cookie('code', null);;
        cookie('uid', null);

        Cookie('hostuid',null);
        Cookie('hostname',null);
        Cookie('database',null);
        Cookie('username',null);
        Cookie('password',null);
        Cookie('prefix',null);
       // return redirect('/admin/Login/index');
        return $this->redirectTo(url('/admin/Login/index'));
        //  $this->success('退出成功！','Login/index');
    }

    //会员管理
    public function users(){
       $users= Db::name('users')->order('last_login_time desc')->paginate(20);
        View::assign([
            'users'=>$users,

        ]);
        return View::fetch('users');
    }

    //用户开启禁用
    public function status(){
        if(request()->isPost()){
            $data=input('post.');
            if ($data['status']==1){
                $status=0;
            }else{
                $status=1;
            }
            $edit=Db::name('users')->where('id','=',$data['id'])->update(['status'=>$status]);
            if ($edit){
                return json(['code'=>1,"msg"=>'操作成功']);
            }
            return json(['code'=>0,"msg"=>'操作失败!']);
        }
    }

    //修改个人信息
    public function adminedit(){
       $admin= Db::name('admin')->where('id','=',Cookie::get('uid'))->find();
        View::assign([
            'admin'=>$admin,

        ]);
        return View::fetch('adminedit');
    }
    public function ad_edit(){
        if(request()->isPost()){
            $data=input('post.');

            if ($data['pass_word']!==$data['pass']){
                return json(['code'=>0,"msg"=>'新密码和重复密码不一致!']);
            }
            $adminarr=Db::name('admin')->where('id','=',$data['id'])->find();
            if(!$adminarr){
                return json(['code'=>0,"msg"=>'修改账号不存在!']);
            }
            if (md5($data['password'])!==$adminarr['password']){
                return json(['code'=>0,"msg"=>'原始密码错误!']);
            }

            ksort($data);//排序
            $sign_data_str=http_build_query($data);

            $code=md5($sign_data_str);

            $adminupdate= Db::name('admin')->where('id','=',$data['id'])->update(['password'=>md5($data['pass_word']),'login_code'=>$code]);

            if ($adminupdate){

                return json(['code'=>1,"msg"=>'操作成功']);
            }
            return json(['code'=>0,"msg"=>'操作失败!']);
        }

        View::assign([
            'id'=>input('id'),

        ]);

        return View::fetch('ad_edit');
    }
    public function phone(){
        if(request()->isPost()){
            $data=input('post.');

            $adminupdate= Db::name('admin')->where('id','=',$data['id'])->update(['phonenumber'=>$data['phonenumber']]);

            if ($adminupdate){

                return json(['code'=>1,"msg"=>'操作成功']);
            }
            return json(['code'=>0,"msg"=>'操作失败!']);
        }
        $admin=Db::name('admin')->field('id,phonenumber')->find(input('id'));

        View::assign([
            'admin'=>$admin,
        ]);
        return View::fetch('phone');
    }

    public function email(){
        if(request()->isPost()){
            $data=input('post.');

            $adminupdate= Db::name('admin')->where('id','=',$data['id'])->update(['email'=>$data['email']]);

            if ($adminupdate){

                return json(['code'=>1,"msg"=>'操作成功']);
            }
            return json(['code'=>0,"msg"=>'操作失败!']);
        }
        $admin=Db::name('admin')->field('id,email')->find(input('id'));

        View::assign([
            'admin'=>$admin,
        ]);
        return View::fetch('email');
    }

    public function status_vip($id){

        $users= Db::name('users')->find($id);

        if ($users['vip']==0){
            $users= Db::name('users')->where('id','=',$id)->update(['vip'=>3]);
        }else{
            $users= Db::name('users')->where('id','=',$id)->update(['vip'=>0]);
        }
        if ($users){
            return json(['code'=>1,"msg"=>'操作成功']);
        }
        return json(['code'=>0,"msg"=>'操作失败!']);
    }
    //用户档案管理
    public function usersedit($id){
        $users= Db::name('users')->find($id);


        $users['gold']= Db::name('integral')->where('uiid','=',$id)->sum('gold');
        $users['sum']= Db::name('users')->where('iid','=',$id)->select()->count();


        $users['integral']= Db::name('integral')->where('uid','=',$id)->sum('integral');

        View::assign([
            'users'=>$users,
        ]);
        return view();
    }
}