<?php
/**
 * Created by PhpStorm.
 * User: HP
 * Date: 2022/3/11
 * Time: 10:20
 */

namespace app\admin\controller;
use think\facade\Db;
use think\facade\Cache;
use think\facade\View;

use app\admin\model\Archives as ArchivesModel;
use app\admin\model\Cate;
use app\admin\model\Word;
use think\exception\ValidateException;
use app\admin\validate\Archives as ArchivesValidate;
class Archives extends Common
{
    public function index(){


        return view();
    }




    public function lstselect($limit=15){


        $data=input('post.');
        $curr = input('page');

//        $data['cate_id']=input('cate_id');
//        $data['title']=input('title');
        $data= ArchivesModel::LstSelect($limit,$curr,$data);

        return json($data);
    }
    public function add(){

        if(request()->isPost()){
            Cache::delete('daisheng');
            $data=input('post.');


            //验证
            try {
                $result =  validate(ArchivesValidate::class)->scene('add')->check($data);
            } catch (ValidateException $e) {
                // 验证失败 输出错误信息
                return returnjson(0,$e->getError());
            }
            if(!empty($data['keywords'])){
                $data['keywords']=str_replace('，', ',', $data['keywords']);
                $data['keywords']=preg_replace('# #','',$data['keywords']);
            }
            if(!empty($data['description'])){
                $data['description']=cut_str(delhtml($data['description'] ),120);
            }
//            $data['content']= $_GET['content'];
            $add= ArchivesModel::GetAdd($data);
            if($add){
                $runtime=app()->getRootPath().'/runtime/';
                (new ArchivesModel())->runtime($runtime);
                return returnjson(1,'添加成功');
            }else{
                return returnjson(0,'添加失败！标题或发布栏目不能为空');
            }

        }

        $ad=isset($_GET['ad'])?$_GET['ad']:'ueditor';


        View::assign(array(
            'attr'=>input('attr'),
            'ad'=>$ad,
            'markdown'=>config("route.markdown"),
            'ueditor'=>config("route.ueditor"),
        ));
        return view();
    }
    public function edit()
    {
        if(request()->isPost()){

            Cache::delete('daisheng');
            $data=input('post.');
            if(isset($data['name'])){
                if (isset($data['name']) && $data['name'] =='time'){

                    $data['click']=strtotime($data['click'].date('H:i:s') );
                }

               $uedit= Db::name('archives')->where('id','=',$data['id'])->update([$data['name']=>$data['click']]);
               if ($uedit){
                   return returnjson(1,'编辑成功');
               }
                return returnjson(0,'编辑失败');
            }
            unset($data['descriptioncheckbox'],$data['keywordscheckbox']);
            if(!empty($data['keywords'])){
                $data['keywords']=str_replace('，', ',', $data['keywords']);
                $data['keywords']=preg_replace('# #','',$data['keywords']);
            }
            if(!empty($data['description'])){
                $data['description']=cut_str(delhtml($data['description'] ),120);
            }

//            $data['content']= $_GET['content'];
            $add= ArchivesModel::Getedit($data);
            if($add){
                $runtime=app()->getRootPath().'/runtime/';

                (new ArchivesModel())->runtime($runtime);
                return returnjson(1,'编辑成功');
            }else{
                return returnjson(0,'添加失败！标题或发布栏目不能为空');
            }
        }
        $cid=input('cid');
        $data['archives']= Db::name('archives')->find($cid);

        if ($data['archives']['markdown']=='markdown'){
            $data['archives']['content']=json_decode($data['archives']['content'],true);

        }

        $data['imgres']= json_decode($data['archives']['imgres'],true);

        $archives_id= Db::name('archives_id')->where('aid','=',$cid)->group('cate_id')->column('cate_id');
        $data['archives_id']=implode(',',$archives_id);

        $data['pics']= Db::name('pics')->where('aid','=',$cid)->order('sort desc')->select();

        foreach ($data['pics'] as $v){
            $pics[]=$v['pic'];
        }
        if (isset($pics)){
            $pics=  implode(',',$pics);
        }else{
            $pics='';
        }
        $ad=isset($_GET['ad'])?$_GET['ad']:$data['archives']['markdown'];

        View::assign(array(
            'archives'=>$data,
            'pic'=>$pics,
            'ad'=>$ad,
            'ueditor'=>config("route.ueditor"),
            'markdown'=>config("route.markdown"),
        ));
        return view();
    }
    //图片排序
    public function picsort($id){
        if(request()->isPost()) {
            $data = input('post.');
           $edit= Db::name('pics')->update($data);
           if ($edit){
               return json(['code'=>1,'msg'=>'更新成功']);
           }
            return json(['code'=>0,'msg'=>'更新错误']);
        }
       $pic= Db::name('pics')->where('aid','in',$id)->order('sort desc')->select();

        View::assign(array(
            'pic'=>$pic,
        ));
        return view();
    }
    public function del(){
        $id=input("cateid");

        $del= Db::name('archives')->where('id','in',json_decode($id))->delete();
        if ($del){
            Cache::delete('daisheng');
            Db::name('archives_id')->where('aid','in',json_decode($id))->delete();
            Db::name('pics')->where('aid','in',json_decode($id))->delete();
            return json(['code'=>1,'msg'=>'删除成功']);
        }
        return json(['code'=>0,'msg'=>'删除失败']);
    }

    public function cate(){
        $cateResList=Db::name('arc_cate')->where('cate_attr','=',1)->select();
        $cateRes= create_tree_list(0,$cateResList);
        $Cate= new Cate();
        $cate= $Cate->GetCate($cateRes);

        return json(['code'=>1,'msg'=>'栏目','data'=>$cate]);
    }
    public function catetrue(){
        $cateid=input('arcidr');

        $cate= Db::name('arc_cate')->where('id','in',$cateid)->select();
        $arra=[];
        $arre=[];
        foreach ($cate as $k=>$v){
            $arr['name']=$v['cate_name'];
            $arr['value']=$v['id'];
            $arr['selected']=true;
            $arra[]=$arr;
        }
        return json(['code'=>1,'msg'=>'栏目','data'=>$arra]);
    }

    public function status($id){

        $id= json_decode($id);
       if (is_array($id)){
           $edit= Db::name('archives')->where('id','in',$id)->update(['status'=>1]);
           return json(['code'=>1,'msg'=>'待审核']);
       }

        $archives= Db::name('archives')->find($id);
        if ($archives['status']==1){

            $edit= Db::name('archives')->where('id','=',$id)->update(['status'=>0]);
            return json(['code'=>1,'msg'=>'待审核']);
        }else{

            $edit= Db::name('archives')->where('id','=',$id)->update(['status'=>1]);
            return json(['code'=>1,'msg'=>'已审核']);
        }
        return json(['code'=>0,'msg'=>'修改失败']);
    }

    public function attr_time($id){
        $archives= Db::name('archives')->find($id);

        if ($archives['attr_time']==0){

            $edit= Db::name('archives')->where('id','=',$id)->update(['attr_time'=>time()]);
            return json(['code'=>1,'msg'=>'置顶']);
        }else{

            $edit= Db::name('archives')->where('id','=',$id)->update(['attr_time'=>0]);
            return json(['code'=>1,'msg'=>'我要置顶']);
        }
        return json(['code'=>0,'msg'=>'修改失败']);
    }

    //word上传导入
    public function WordUpload(){

        $dir=app()->getRootPath().'/runtime/word';
        if (!file_exists($dir)){
            mkdir($dir, 0700, true);
        }
      $wordurl=  move_uploaded_file($_FILES["avatar"]["tmp_name"], $dir.'/'. $_FILES["avatar"]["name"]);
       if ($wordurl){
           $html= (new Word())->wordhtml($dir.'/'. $_FILES["avatar"]["name"]);
       }
        @unlink($dir.'/'. $_FILES["avatar"]["name"]);
        return json(['code'=>1,'msg'=>$html]);
    }

}