<?php
/**
 * Created by PhpStorm.
 * User: HP
 * Date: 2022/3/28
 * Time: 11:43
 */

namespace app\admin\controller;
use think\facade\Db;
use think\facade\View;
use app\admin\model\AuthGroup as AuthGroupModel;
use think\facade\Cookie;
use app\admin\validate\AuthGroup as AuthGroupvalidate;
use think\exception\ValidateException;
use liliuwei\think\Auth;
class AuthGroup extends Common
{

    public function index(){
        return view();
    }

    public function select($limit=15){
        $curr = input('page');

        $data= AuthGroupModel::LstSelect($limit,$curr);

        return json($data);
    }
    public function add(){
        if(request()->isPost()){
            $data=input('post.');
            try {
                $result =  validate(AuthGroupvalidate::class)->scene('add')->check($data);
            } catch (ValidateException $e) {
                // 验证失败 输出错误信息
                return returnjson(0,$e->getError());

            }
            return AuthGroupModel::GstAdd($data);

        }
        return view();
    }
    public function edit(){
        if(request()->isPost()){
            $data=input('post.');
            try {
                $result =  validate(AuthGroupvalidate::class)->scene('edit')->check($data);
            } catch (ValidateException $e) {
                // 验证失败 输出错误信息
                return returnjson(0,$e->getError());

            }
            return AuthGroupModel::Gstedit($data);

        }
        $id=input('id');

        $auth_group =Db::name('auth_group')->find($id);
        View::assign(array(
            'authgroup'=>$auth_group
        ));
        return view();
    }
    public function del($id){
      $del=Db::name('auth_group')->delete($id);
      if ($del){
          return returnjson(1,'删除成功');
      }

        return returnjson(0,'删除失败');
    }


    public function authRule(){
        $data=Db::name('authRule')->field('id as value,title as name,pid')->order('sort desc,id desc')->select()->toArray();

        $datares= (new AuthGroupModel())->catetree($data,0,'children');

        return json(['code' => 1, 'msg' => '分配权限成功','data'=>$datares]);

    }


    public function authRuletrue(){
        $data=input('rules');
        $data=Db::name('authRule')->where('id','in',$data)->field('id as value,title as name,pid')->order('sort desc,id desc')->select();
        $datares=[];
        foreach ($data as $k=>$v){
            $datares[$k]['value']=$v['value'];
            $datares[$k]['name']=$v['name'];
            $datares[$k]['selected']=true;
        }

        return json(['code' => 1, 'msg' => '分配权限','data'=>$datares]);
    }

    public function power(){
        if(request()->isPost()){
            $data=input('post.');

            $data_id = checkedData($data['checkedData']);

            $idrules=implode(',',$data_id);

            $save=Db::name('authGroup')->save(['id'=>$data['id'],'rules'=>$idrules]);
            if($save !== false){
                return json(['code' => 1, 'msg' => '分配权限成功']);
            }else{
                return json(['code' => 0, 'msg' => '分配权限失败']);
            }
            return;
        }
      

        $id=input('id');
        $authGroups=Db::name('authGroup')->field('id,title')->cache(true)->find($id);
        View::assign([
            'authGroups'=>$authGroups,
        ]);
        return view();
    }

    public function rules(){
        $id=input('id');
          $auth=new Auth();
        $group=$auth->getGroups(Cookie::get('uid'));


        $authGroups=Db::name('authGroup')->find($id);

        if (Cookie::get('uid')!=='1'){
            $ruleRes=Db::name('authRule')->order('sort desc,id desc')->where('id','in',$group[0]['rules'])->field('id,pid,title')->select()->toArray();
        }else{
            $ruleRes=Db::name('authRule')->order('sort desc,id desc')->field('id,pid,title')->select()->toArray();
        }

        
       // $ruleRes=Db::name('authRule')->order('sort desc,id desc')->field('id,pid,title')->select()->toArray();
        $ruleTree=ruleRes(0,$ruleRes);
        $rules=explode(',',$authGroups['rules']);
        $rules_id=[];
        foreach ($rules as $v){
           $ar= Db::name('authRule')->field('id,pid')->find($v);
            $ararr= Db::name('authRule')->where('pid','=',$v)->find();
           if ($ar['pid']>0 || !$ararr){
               $rules_id[]=$v;
           }
        }
        $rules_idarr=[];
        foreach ($rules_id as $v){
            $ar= Db::name('authRule')->where('pid','=',$v)->field('id,pid')->find();
            if (!$ar){
                $rules_idarr[]=$v;
            }
        }

        $data=[
            'ruleRes'=>$ruleTree,
            'rules'=> $rules_idarr
        ];

        return json(['code' => 1, 'msg' => '分配权限成功','data'=>$data]);
    }

}