<?php
/**
 * Created by PhpStorm.
 * User: pc
 * Date: 2021/4/12
 * Time: 13:16
 */

namespace app\admin\controller;
use think\facade\Db;
use think\facade\Cookie;
use think\facade\View;
use app\admin\model\Conflist;
class File extends Common
{

    /**
     * 显示资源列表
     *
     * @return \think\Response
     */
    public function index()
    {

        $currdir= input('path')?input('path'):app()->getRootPath() .'/template';
        

        $currdir=iconv('UTF-8','GB2312',$currdir);
        if ($currdir){
            if (file_exists($currdir)){
                if (stripos($currdir,$currdir)===0 && stripos($currdir,$currdir.'..')===false){
                    chdir($currdir);
                }
            }
        }

        if(empty($currdir) || !file_exists($currdir)){
            return json(['code'=>0,'msg'=>'文件不存在']);
        }
        $rootdir=getcwd();
        $count=explode('/',$rootdir);

        if (count($count)<0){
            return json(['code'=>0,'msg'=>'目录为空或已是最顶级目录']);
        }
        $dir=opendir($rootdir);
        $data=[];
        $num=[];
        $num['dir']=0;
        $num['file']=0;
        while ($filename=readdir($dir)){
            if ($filename!="." && $filename!=".."){

                if (is_dir($filename)){
                    $arr['icon']="icon-24gf-folderPlus";
                    $arr['flag']=1;
                    $num['dir']++;
                }else{
                    $arr['icon']=$this->seticon($filename);
                    $arr['flag']=0;
                    $num['file']++;
                }
                $arr['currdir']=iconv('GB2312','UTF-8',getcwd()."/".$filename);

                $arr['name']=$filename;

                $arr['size']=filesize($filename);
                $arr['ctime']=filectime($filename);
                $arr['mtime']=filemtime($filename);
                $data[]=$arr;
            }
        }

        array_multisort(array_column($data,'flag'),SORT_DESC,$data);
        $curr=input('page');
        $currpage=$this->page_array($data,10,$curr);
        $rootdir = str_replace('/', '\\', $rootdir);
        $public = str_replace('\\', '/', app()->getRootPath());
        View::assign([
            'public'=>$public,
            'curdir'=>$rootdir,
            'dirs'=>$currpage['data'],
            'page'=>$currpage['page'],
            'num'=>$num,
            'uid'=>Cookie::get('uid')
        ]);
        return view();
    }



    /**
     * @param $filename
     * @return string
     */
    public function seticon($filename){
        $exc=strtoupper(substr($filename,strrpos($filename,".")));
        $icon='';
        switch ($exc){
            case ".HTML":
                $icon="icon-html1";
                break;
            case ".PHP":
                $icon="icon-suffix-php";
                break;
            case ".JS":
                $icon="icon-js1";
                break;
            case ".BMP":
                $icon="icon-picture";
                break;
            case ".PNG":
                $icon="icon-picture";
                break;
            case ".JPEG":
                $icon="icon-picture";
                break;
            case ".GIF":
                $icon="icon-picture";
                break;
            case ".CSS":
                $icon="icon-css1";
                break;
            case ".JPG":
                $icon="icon-picture";
                break;
            case ".JSON":
                $icon="icon-js1";
                break;
            case ".DOCX":
                $icon="icon-DOCX";
                break;
            case ".DOC":
                $icon="icon-DOCX";
                break;
            case ".MP4":
                $icon="icon-shipin";
                break;
            case ".FLV":
                $icon="icon-shipin";
                break;
            case ".SWF":
                $icon="icon-shipin";
                break;
            case ".RAR":
                $icon="icon-yasuobao";
                break;
            case ".ZIP":
                $icon="icon-yasuobao";
                break;
            case ".ARJ":
                $icon="icon-yasuobao";
                break;
            default :
                $icon='icon-file';
        }
        return $icon;
    }

    private function page_array($arr, $page=10, $curr){
        $total=ceil(count($arr)/$page);
        if($curr<=0) $curr=1;
        if($curr>$total) $curr=$total;
        $data=array_slice($arr,($curr-1)*$page,$page);
        return [
            'data'=>$data,
            'page'=>[
                'count'=>count($arr),
                'limit'=>$page,
                'curr'=>$curr
            ]
        ];

    }


    public function renames(){
        if(request()->isAjax()){
            $file=iconv("UTF-8","GB2312",urldecode(input('file')));
            $filename=input('filename');
            $newfile=iconv("UTF-8","GB2312",dirname($file).'/'.$filename);
            if(file_exists($newfile)){
                return json(['code'=>0,'msg'=>'文件已存在（重名）']);
            }
            @rename($file,$newfile);
            return json(['code'=>1,'msg'=>'重命名成功']);
        }
    }

    //文件编辑

    /**
     * @return \think\response\View
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\ModelNotFoundException
     * @throws \think\exception\DbException
     */
    public function edit(){
        $cata=input('file');


        $file=iconv('UTF-8','GB2312',urldecode(input('file')));

        if(empty($file) || !file_exists($file)){
            return json(['code'=>0,'msg'=>'文件不存在操作异常，文件名称按要求编辑']);
        }
        $arr=['.PHP','.CSS','.JS','.XML','.TXT','.HTML','.HTACCESS','.HTM','.DOCX','.INI'];
        $exc=strtoupper(substr($file,strripos($file,'.')));
        if (!in_array($exc,$arr)){
            return json(['code'=>0,'msg'=>'该文件类型不支持编辑']);
        }

        if (request()->isPost()){

            $content=input('code');
            //打开要编辑的文件
            $fp=fopen($file,'w');

            //写入新内容
            fwrite($fp,$content);//fputs
            //关闭文件
            fclose($fp);
            return json(['code'=>1,'msg'=>'保存成功']);
        }



        $currdir= substr($file,0,strrpos($file,"/"));
        $currdir=iconv('UTF-8','GB2312',$currdir);
        if ($currdir){
            if (file_exists($currdir)){
                if (stripos($currdir,$currdir)===0 && stripos($currdir,$currdir.'..')===false){
                    chdir($currdir);
                }
            }
        }

        if(empty($currdir) || !file_exists($currdir)){
            return json(['code'=>0,'msg'=>'文件不存在']);
        }
        $rootdir=getcwd();
        $count=explode('/',$rootdir);

        if (count($count)<0){
            return json(['code'=>0,'msg'=>'目录为空或已是最顶级目录']);
        }
        $dir=opendir($rootdir);
        $data=[];
        $num=[];
        $num['dir']=0;
        $num['file']=0;
        while ($filename=readdir($dir)){
            if ($filename!="." && $filename!=".."){

                if (is_dir($filename)){
                    $arr['icon']="icon-24gf-folderPlus";
                    $arr['flag']=1;
                    $num['dir']++;
                }else{
                    $arr['icon']=$this->seticon($filename);
                    $arr['flag']=0;
                    $num['file']++;
                }
                $arr['currdir']=iconv('GB2312','UTF-8',getcwd()."/".$filename);

                $arr['name']=$filename;

                $arr['size']=filesize($filename);
                $arr['ctime']=filectime($filename);
                $arr['mtime']=filemtime($filename);
                $data[]=$arr;
            }
        }

        $code=file_get_contents($file);
        View::assign('dirs',$data);
        View::assign('code',$code);
        View::assign('currfile',$file);
        View::assign('ext',$exc);
        return view();
    }
//    文件下载

    /**
     * @param null $currdir
     */
    public function download($currdir=null){
        $file=urldecode($currdir);
        $file=iconv('UTF-8',"GB2312",$file);
        if(!file_exists($file)){
            $this->error("文件不存在");
        }
        $filename=basenamecn(iconv('GB2312',"UTF-8",$file));
        header('Content-Disposition: attachment;filename='.$filename);
        readfile($file);
    }

    //数据删除

    /**
     * @return \think\response\Json
     */
    public function del(){
        if (request()->isAjax()){
            $file=iconv('UTF-8','GB2312',urldecode(input('file')));
            if (is_dir($file)){
                $arr=scandir($file);
                if (count($arr)===2){
                    @rmdir($file);
                    return json(['msg'=>'目录删除成功']);
                }else{
                    return json(['msg'=>'目录(不为空)删除失败！']);
                }
            }
            if (is_file($file)){
                @unlink($file);
                return json(['msg'=>'文件删除成功']);
            }

            return json(['msg'=>'操作异常']);
        }
    }



    public function file(){
        $dir=input('src');


        move_uploaded_file($_FILES["file"]["tmp_name"], $dir.'/'. $_FILES["file"]["name"]);
        return returnjson(1,"上传成功");
    }

    public function new(){
        $data=input('post.');
        $datadir= explode('.', $data['filename']);

        if (!isset($datadir[1])){
            !is_dir($data['file'].'/'.$data['filename']) && mkdir($data['file'].'/'.$data['filename'], 0777, true);
        }else{
            $myfile = fopen($data['file'].'/'.$data['filename'], "w") or die("Unable to open file!");
            fclose($myfile);
        }

        return returnjson(1,"创建完成");
    }

    public function ht($ht){

        switch ($ht) {
            case 'TitleDesc':
                $data='<title>{$confs.name}</title>
<meta name="keywords" content="{$confs.keywords}"/>
<meta name="description" content="{$confs.desc}"/>';
                break;

            case 'Volist':
                $data='{volist name="news6" id="vo" offset="0" length=\'10\' key="k"}
<li>
    <div class="n_img"><a href="{$vo[\'id\']|urlart=###}"
                          title="{$vo.title}">
        <img src="{$vo.picarr[0]?$vo.picarr[0]:\'https://www.hbsjsd.cn/static/index/images/webcon1.jpg\'}"
             alt="{$vo.title}" title="{$vo.title}"> </a>
    </div>
    <div class="n_txt">
        <h2><a href="{$vo[\'id\']|urlart=###}" title="{$vo.title}">{$vo.title}</a>
            <time>{$vo.time|date=\'Y-m-d\'}</time>
        </h2>
        <h3>
            {$vo.description?$vo.description|delhtml=###|cut_str="80":$vo.content|delhtml=###|cut_str="80"}</h3>
        <div class="n_more"><a href="{$vo[\'id\']|urlart=###}">+阅读更多</a>
            <time>{$vo.time|date=\'Y-m-d\'}</time>
        </div>
     
    </div>
</li>
{/volist}';
                break;
            case 'A':
                $data="{:url('/Article/index',array('aid'=>\$vo['id']))}";
                break;
            case 'Atitle':
                $data="{\$vo.title|cut_str='30'}";
                break;
            case 'Description':
                $data="{\$vo.description?\$vo.description|delhtml=###|cut_str='8':\$vo.content|delhtml=###|cut_str='80'}";
                break;
            case 'Time':
                $data="{\$vo.time|date='Y-m-d'}";
                break;
            case 'Click':
                $data="{\$vo.click}";
                break;
            case 'Pic':
                $data="{\$vo.picarr[0]?\$vo.picarr[0]:'默认图片URL'}";
                break;
            case 'CateName':
                $data='<a href="{:url(\'/Cate/index\',array(\'cid\'=>$vo[\'cate_id\']))}">{$vo.cate_name}</a>';
                break;
            case 'Url':
                $data='{$vo.url}';
                break;
            case 'Page':
                $data='<div class="h1">{$page1.title}</div>
<div class="box">{$page1.content|delhtml=###|cut_str=\'80\'}</div>';
                break;
            case 'Banner':
                $data='{volist name="links" id="vo" offset="0" length=\'5\' key="k"}
    <div class="carousel-item {if condition=\'$k-1 eq 0\'}active{/if}" data-interval="5000">
        <img src="{$vo.img}"  class="d-block w-100" alt="{$vo.name}">
        <div class="carousel-caption d-none d-md-block">
           {$vo.desc|raw}
        </div>
    </div>
{/volist}';
                break;
            case 'Pos':
                $data='{volist name="pos" id="cate"}
   <a href="{if condition=\'$cate[\'cate_attr\'] eq 1\'}{:url(\'/cate/index\',array(\'cid\'=>$cate[\'id\']))}{/if}
{if condition=\'$cate[\'cate_attr\'] eq 2\'}{:url(\'/page/index\',array(\'cid\'=>$cate[\'id\']))}{/if}
{if condition=\'$cate[\'cate_attr\'] eq 3\'}{$cate.link}{/if}">{$cate.cate_name}</a> {if condition="$i neq count($pos)"}<i class="iconfont icon-jiantou" style="font-size: 0.875rem"></i>{/if}
{/volist}';
                break;
            case 'sonCateRes':
                $data='{volist name="sonCateRes" id="vo"}
<li class="{if condition=\'$vo.id eq $cid\'}active{/if}"><a href="{$vo.cate_attr|makeurl=###,$vo.id}"  >
    {$vo.cate_name}
    </a></li>
{/volist}';
                break;
            default:
                $data='错误参数';
                break;
        }


       return  $data;
    }
    public function home(){
        return view();
    }
}