<?php
declare (strict_types = 1);

namespace app\admin\controller;
use think\db\Query;
use think\facade\Cache;
use think\facade\Cookie;
use think\facade\Db;
use think\facade\View;
use liliuwei\think\Auth;
use think\facade\Request;

use DOMDocument;//DOMXPath
use DOMXPath;

use OSS\Core\OssException;
use OSS\Core\OssUtil;
use OSS\OssClient;

use app\api\exception\HttpExceptions;
class Index extends Common
{
    public $prefix='';
    public function index()
    {

        $this->weburl();
        $auth=new Auth();

        $group=$auth->getGroups(Cookie::get('uid'));

        $menu=Db::name('authRule')->where('id','in',$group['0']['rules'])->where('show','=',1)->order('sort desc')->select()->toArray();

        $authRule= index_list(0,$menu);

        View::assign([
            'cateRes'=>$authRule,
            "uname"=>Cookie::get('uname'),
            'uid'=>Cookie::get('uid'),

        ]);
        return view();
    }

    public function welcome(){

        $logs=Db::name('logs')->where('operator','=',Cookie::get('uid'))->order('id desc')->find();

        // 请求查看更新

        if (!Cache::get('gengxing')){
            $data=Cache::get('gengxing');
            $banben['title']='v1.1.1';
            $url=config("view.weburl").'/banbenggx';
            // $url=config('view.gx').'/index/date_zxgx';
            $dateres=$this->http_request($url,$banben);
            $dataarr=json_decode($dateres,true);

            if ($dataarr['data']!==[]){
                $data=$dataarr['data'];
            }else{
                $data[0]['title']=0;
                $data[0]['url']='0';
            }
            View::assign([
                'gx'=>$data,
            ]);
            Cache::set('gengxing', $data, 86400);

        }
//获取帮助
        if (!Cache::get('dateres')){
            $_da = [
                'cid' => 9,
                'limit' => 15,
                'page' => 1
            ];
            $url = config("view.weburlv1") . '/ArchivesList?timestamp=' . time();
            $_dateres = $this->http_request($url, $_da);
            $_dateres = json_decode($_dateres, true);
            View::assign([
                'dateres'=>$_dateres
            ]);
            Cache::set('dateres', $_dateres['data']['rows'], 86400);
        }

        $title=Db::name('authRule')->where('show','=',1)->order('sort desc')->where('pid','=',0)->field('title')->select()->toArray();


        View::assign([
            'logs'=>$logs,
            "uname"=>Cookie::get('uname'),
            'banquan'=> config("view.banquan"),
            'gx'=>Cache::get('gengxing'),
            'titlename'=>$title,
            'dateres'=>Cache::get('dateres'),
            'banben'=> config("view.banquan.banben"),

        ]);



        return view();
    }
    //网站更新
    public function gengxing(){

        $url=input('id');
        $name=substr($url, strripos($url, "/") + 1);

        $path=app()->getRootPath().'public/static/';
        $file=$this->downFile($url,$path);
        if ($file){

            $fi= $this->unzip_file($path.$name,app()->getRootPath());

            if ($fi){
                $file=unlink($path.$name);
                Cache::delete('gengxing');
                if (config("install.sql")){
                    Db::query(config("install.sql"));
                    unlink(app()->getRootPath().'config/install.php');
                }

                return json(['code'=>1,"msg"=>'更新完成']);
            }else{
                return json(['code'=>0,"msg"=>'更新失败']);
            }
        }
    }



//获取系统配置
    protected function get_sys_info()
    {

        $system=[
            'version'=>"v4.0.0",
            //服务器IP
            'ip'=>gethostbyname($_SERVER['SERVER_NAME']),
            //主机名
            'host'=>$_SERVER['SERVER_NAME'],
            //服务器操作系统
            'os'=>PHP_OS,
            //运行环境
            'server'=>$_SERVER["SERVER_SOFTWARE"],
            //服务器端口
            'port'=>$_SERVER['SERVER_PORT'],
            //PHP版本
            'php_ver'=>PHP_VERSION,
            //数据库前缀
            'mysql_ver'=>config('database.connections.mysql.database'),
            //访问ip
            'fw_ip'=>Request::ip(),
            //数据库
            'database'=>Db::query('select version() as ver')[0]['ver'],
            //域名
            'domain'=>$_SERVER['HTTP_HOST'],
            'timezone'=>function_exists("date_default_timezone_get") ? date_default_timezone_get() : "no_timezone",
            'file_upload'=> @ini_get('file_uploads') ? ini_get('upload_max_filesize') : 'unknown',
            'max_ex_time' => @ini_get("max_execution_time").'s', //脚本最大执行时间
            'safe_mode'=> (boolean)ini_get('safe_mode') ? 'YES' : 'NO',//safe_mode = Off
            'zlib'=> function_exists('gzclose') ? 'YES' : 'NO',//zlib
            'curl' => function_exists('curl_init') ? 'YES' : 'NO',
            'memory_limit'=> ini_get('memory_limit'),
            'update'=>config('update'),
        ];

        return $system;
    }

    //获取2点之间的距离

    public function GetDistance($lat1, $lng1, $lat2, $lng2){

        $radLat1 = $lat1 * (3.1415926535898 / 180);

        $radLat2 = $lat2 * (3.1415926535898 / 180);

        $a = $radLat1 - $radLat2;

        $b = ($lng1 * (3.1415926535898 / 180)) - ($lng2 * (3.1415926535898 / 180));

        $s = 2 * asin(sqrt(pow(sin($a/2),2) + cos($radLat1)*cos($radLat2)*pow(sin($b/2),2)));

        $s = $s * 6378.137;

        $s = round($s * 10000) / 10000;

        return $s;

    }
    //清楚缓存
    public function runtime(){

        $runtime=app()->getRootPath().'/runtime/';

        if (delete_dir_file($runtime)) {
            return json(['code'=>1,"msg"=>'清除缓存成功']);
        } else {
            return json(['code'=>0,"msg"=>'清除缓存失败']);
        }
    }


    public function checkUrl($url)
    {
        # 定义状态码 httpcode
        $httpcode = 0;
        $ch = curl_init();
        $timeout = 1; // 设置超时的时间[单位：秒]
        curl_setopt($ch,CURLOPT_FOLLOWLOCATION,1);
        curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
        curl_setopt($ch, CURLOPT_HEADER, 1);
        curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
        curl_setopt($ch,CURLOPT_URL,$url);
        curl_exec($ch);
        # 获取状态码赋值
        $httpcode = curl_getinfo($ch,CURLINFO_HTTP_CODE);
        curl_close($ch);
        # 返回状态码
        return $httpcode; // 200正常 其他异常
    }
    //修改调试模式
    public function env(){

        $database_file=app()->getRootPath().'/'.'.env';

        if (file_get_contents($database_file)=="APP_DEBUG=true"){
            @file_put_contents($database_file, 'APP_DEBUG=false');
        }else{
            @file_put_contents($database_file, 'APP_DEBUG=true');
        }
        return json(['code'=>1,"msg"=>'设置完成']);
    }


}
