<?php
/**
 * Created by PhpStorm.
 * User: pc
 * Date: 2021/4/8
 * Time: 11:04
 */

namespace app\admin\controller;
use  app\admin\model\Model as ModelModel;
use think\facade\View;
use think\facade\Request;
use think\facade\Db;
use app\admin\model\ModelFields;
class Model extends Common
{
    //附表列表
    public function index(){

        $prefix=config("database.connections.mysql.prefix");//获取数据表前缀

        View::assign( 'prefix',$prefix);

        return view();
    }
    public function store($limit=10){
        $curr = input('page');
        $data= (new ModelModel())->getlist($limit,$curr);
         return json($data);

    }
    //添加附表
    public function add(){
        if (request()->isPost()){
            $data=input('post.');
           $add=  new ModelModel();
           $addres=$add->getadd($data);
            return $addres;
        }

        return view();
    }

    //修改附表
    public function edit(Request $request){
        if (request()->isPost()){
            $data=input('post.');

            $edit= new ModelModel();
            $editres=$edit->getedit($data);

            return $editres;
        }
        //获取站点

        $id=input('id');
        $model=ModelModel::find($id);
        View::assign('model',$model);
        return view();
    }

    //附表删除
    public function del()
    {
        $modelId=input('id');

        $tableName=input('table_name');

        $model= ModelModel::find($modelId);
        $del = $model->delete();
        $sql="drop table {$tableName}";
        Db::execute($sql);
        $delFields= ModelFields::where('model_id','=',$modelId)->delete();

        if($del){

            return returnjson(1,'模型删除成功');
        }else{
            return returnjson(0,'模型删除失败');
        }

    }
    public function modellist(){
        $uid=input('id');
        $model= ModelModel::find($uid);
        $modelfields=ModelFields::order('sort desc, id desc')->where('model_id','=',$uid)->paginate(['list_rows'=>10,'query' => request()->param()]);
        $prefix=config("database.connections.mysql.prefix");//获取数据表前缀
        View::assign('prefix',$prefix);
        View::assign('table_name',$model['table_name']);
        View::assign('modelfields',$modelfields);
        return view();
    }

    public function modeladd(){

        if (request()->isPost()){
            $data=input('post.');
           $ModelFields= new ModelFields();
           $datares= $ModelFields->getmodeladd($data);
            return $datares;
        }

        $modelRes=ModelModel::field('id,model_name')->select();

        View::assign('modelRes',$modelRes);

        return view();
    }

    public function modeledit(){
        if (request()->isPost()){
            $data=input('post.');
            $ModelFields= new ModelFields();
            $datares= $ModelFields->getedit($data);
            return $datares;
        }

        $id=input('id');
        $modelfields=ModelFields::find($id);
        View::assign('modelfields',$modelfields);
        $modelRes=ModelModel::field('id,model_name')->select();
        View::assign('modelRes',$modelRes);
        return view();
    }

    //ajax删除字段
    public function ajaxdel(){
        $modelFieldsId=input('id');
        //获取前缀

        $ModelFields= new ModelFields();
        $datares= $ModelFields->ajaxdel($modelFieldsId);

        return $datares;

    }

    //表格发布
    public function table($id=''){
        if ($id==''){
            $uid=ModelModel::order('id desc')->find();
            $id=$uid['id'];
        }


        $ModelFields= new ModelFields();
        $diyFields= ModelFields::where('model_id','in',$id)->order('sort desc, id desc')->select();
        $modelRes=ModelModel::field('id,model_name,status')->order('id desc')->select();
        $table_name=ModelModel::field('table_name')->find($id);
        View::assign('modelRes',$modelRes);
        View::assign('diyFields',$diyFields);
        View::assign('id',$id);
        View::assign('table_name',$table_name['table_name']);
        return view();
    }

    public function tablelist($id=''){

        if ($id==''){
            $uid=ModelModel::order('id desc')->find();
            $id=$uid['id'];
        }
        $model_name=ModelModel::field('id,table_name')->find($id);
        $diyFields= ModelFields::where('model_id','in',$id)->order('sort desc,id desc')->where('attr','=',1)->select();
      $data=  Db::name($model_name['table_name'])->order('id desc')->paginate(20);

        $modelRes=ModelModel::field('id,model_name,status')->order('id desc')->select();
        View::assign([
            'modelRes'=>$modelRes,
            'data'=>$data,
            'model_name'=>$model_name,
            'id'=>$id,
            'diyFields'=>$diyFields
        ]);
        return view();
    }
    public function tableadd(){
        $data=input('post.');

        $add= Db::name($data['table_name'])->strict(false)->insert($data);
        if($add){
            return returnjson(1,'发布成功');
        }else{
            return returnjson(0,'发布失败');
        }
    }

    public function tableedit(){
        if (request()->isPost()){
            $data=input('post.');
        
            $edit= Db::name($data['table_name'])->strict(false)->update($data);
            if($edit){
                return returnjson(1,'修改成功');
            }else{
                return returnjson(0,'修改失败');
            }
        }
        $id=input('id');
        $table_name=input('table_name');
        $model_id=input('model_id');
        $model_name=ModelModel::field('id,table_name')->find($model_id);
        $diyFields= ModelFields::where('model_id','in',$model_id)->order('sort desc,id desc')->select();
        $data=Db::name($table_name)->find($id);
        View::assign([
            'diyvals'=>$data,
            'diyFields'=>$diyFields,
            'table_name'=>$model_name['table_name']
        ]);
        return view();
    }
    public function tabledel(){
        $data=input('post.');
       $del= Db::name($data['table_name'])->delete($data['id']);
        if($del){
            return returnjson(1,'删除成功');
        }else{
            return returnjson(0,'删除失败');
        }
    }
    public function setsort(){
        $data=input('post.');
        $edit=ModelFields::where('id','=',$data['id'])->update(['sort'=>$data['sort']]);
        if($edit){
            return returnjson(1,'成功');
        }else{
            return returnjson(0,'失败');
        }
    }

}