<?php
/**
 * Created by PhpStorm.
 * User: HP
 * Date: 2022/3/10
 * Time: 11:22
 */

namespace app\admin\controller;

use think\facade\Db;
use think\facade\View;
use think\facade\Cookie;
use app\admin\model\Weixin as Weixinmodel;
use app\admin\model\Upload;
class Weixin extends Common
{

    public  $appid='';
    public  $secret='';
    protected  function initialize()
    {
        parent::initialize(); // TODO: Change the autogenerated stub
        
        $conf= Db::name('conf')->field('weixin')->order('id desc')->find();
   
        if(!$conf['weixin']){
        	 return json(['code' => 0, 'msg' => '未配置微信appid']);
        }
        $confRes=json_decode($conf['weixin'],true);
        $this->appid=$confRes['appid'];
        $this->secret=$confRes['appSecret'];
    }


//微信公众号配置
    public function weixinconf(){
        if (request()->isPost()){
            $data=input('post.');
           if ($data['id']!==''){
               $id=$data['id'];
               unset($data['id']);
               $weixinres=Db::name('conf')->where('id','=',$id)->update(['weixin'=>json_encode($data)]);
               return json(['code' => 1, 'msg' => '编辑成功']);
           }else{
               unset($data['id']);
               $weixinres=Db::name('conf')->insert(['weixin'=>json_encode($data)]);
               return json(['code' => 1, 'msg' => '编辑成功']);
           }
            return json(['code' => 0, 'msg' => '编辑失败']);
        }
        $weixinres=Db::name('conf')->order('id desc')->field('weixin,id')->find();
        $confRes= json_decode($weixinres['weixin'],true);
        $confRes['id']=$weixinres['id'];

        View::assign([
            'confRes'=>$confRes
        ]);
        return view();
    }
    //获取文章
    public function archives(){
        return view();
    }

    //获取单文章
    public function archivesedit($id){
        $conf=Db::name('conf')->order('id desc')->field('web')->find();
        if (!isset($conf['web'])){
            return json(['code'=>'0','data'=>'未配置网站链接地址']);
        }
        $conf=json_decode($conf['web'],true)['siteurl'];

       $data= Db::name('archives')->alias('a')->join('pics p','p.aid=a.id')->field('a.*,p.pic')->find($id);

        $data['url']='https://'.$conf."/art-$id.html";

        return json($data);
    }
    //微信资源显示页面
    public function wxarc (){
        return view();
    }
    //获取本站微信已发微信信息
    public function wxselect($limit=10){
        $curr = input('page');
        $weixinRes= Db::name('weixin') ->withAttr('time',function ($value){
            return date('Y-m-d', $value);
        })->order('id desc')->select()->toArray();
        $currpage =page_array($weixinRes, $limit, $curr);
        $page= $currpage['page']['count']/$currpage['page']['limit'];

        $data = [
            "code" => 200,
            "msg" => "OK",
            "count" => count($weixinRes),
            "data" => $currpage['data'],
            'status' => 200,
            'pages'=>ceil($page)
        ];

        return json($data);
    }

    //获取选择文章单篇数据并返回数据
    public function wxarchivesedit($id){

        $data= Db::name('weixin')->find($id);

        return json($data);
    }
    //获取全部文章
    public function ajaxarchives($limit=10){
        $curr = input('page');
        $artRes= Db::name('archives')
            ->alias('a')
            ->join('archives_id b','a.id=b.aid')
            ->join('arc_cate c','c.id=b.cate_id')
            ->join('pics p','p.aid=a.id')
            ->group('a.id')
            ->field('a.*,b.cate_id,c.cate_name,p.pic')
            ->withAttr('time',function ($value){
                return date('Y-m-d', $value);
            })
            ->where('a.attr',0)
            ->where('a.status',1)->order('a.id desc,a.attr_time desc,a.time desc')
            ->select()->toArray();
        $currpage =page_array($artRes, $limit, $curr);
        $page= $currpage['page']['count']/$currpage['page']['limit'];

        $data = [
            "code" => 200,
            "msg" => "OK",
            "count" => count($artRes),
            "data" => $currpage['data'],
            'status' => 200,
            'pages'=>ceil($page)
        ];

        return json($data);
    }
    public function index(){

        $weixinres=Db::name('weixin')->where('aid',0)->order('time Desc')->paginate(9);
        $page=$weixinres->render();
        $data= $weixinres->toArray();
        $data_arr=[];
        foreach ($data['data'] as $k => $v) {

            $dataarr=(new Weixinmodel())->selectall($v);


            foreach ($dataarr as $k1=>$v1){
                $data_arr[$k][] =$v1;
            }

        }

        View::assign(['weixinres'=>$data_arr,'page'=>$page]);
        return view();
    }
    //微信公众号图文添加
    public function add(){


        if (request()->isPost()){
            $data=input('post.');

            if ($data['thumb_media_id']==''){

               //上传封面图
                $Weixin=new \app\admin\model\Weixin();
                $access_token=$Weixin->access_token($this->appid,$this->secret);

                if(stripos($data['pic'],'oss-cn') !== false){
                    $saveDir= app()->getRootPath().'/public/runtime_wximg/';
                    $imgpath= crabImage($data['pic'],$saveDir);
                    $imgpath=$saveDir.$imgpath;
                   $imgpath=str_replace('\\', '/', $imgpath);
                }else{
                    $savename= parse_url ($data['pic']);
                    $imgpath =app()->getRootPath().'public'.$savename['path'];
                }
                $url = "https://api.weixin.qq.com/cgi-bin/media/upload?access_token=$access_token&type=image";//上传微信地址和类型
                $result = $this->HttpsUpdateFileServerRequest($url, $imgpath);//执行post
                $wxdata = json_decode($result, true);//返回值
                if (isset($wxdata['media_id']) && $wxdata['media_id']!==''){
                    $data['thumb_media_id']= $wxdata['media_id'];
                    preg_match_all('#<img.*?src="([^"]*)"[^>]*>#i', $data['content'], $match);
                    $data['content']=$this->content_img($match[1],$data['content']);
                }

                $data['time']=time();
                if ($data['id']=='0'){
                    $add=Db::name('weixin')->strict(false)->insertGetId($data);
                    $id=$add;
                }else{
                    $data['aid']=$data['id'];
                    unset($data['id']);
                    $add=Db::name('weixin')->strict(false)->insertGetId($data);
                    $id=$data['aid'];
                }
                return json(['code' => 1, 'data' => $data, 'id' =>$id]);


            }



            $data['time']=time();
            if ($data['id']=='0'){
                $add=Db::name('weixin')->strict(false)->insertGetId($data);
                $id=$add;
            }else{
                $data['aid']=$data['id'];
                unset($data['id']);
                $add=Db::name('weixin')->strict(false)->insertGetId($data);
                $id=$data['aid'];
            }
            return json(['code' => 1, 'data' => $data, 'id' =>$id]);
        }


        $idr=input('id');
        if ($idr){
            $idr=$idr;
        }else{
            $idr=0;
        }
        $weixin=Db::name('weixin')->where('aid','0')->limit(10)->order('sort desc,time Desc')->select();
        $conf= Db::name('conf')->field('web')->order('id desc')->find();

        View::assign(['weixin'=>$weixin,'idr'=>$idr,'conf'=>json_decode($conf['web'],true)]);
        return view();
    }

    public function  content_img($imgurl,$content){
        $Weixin=new \app\admin\model\Weixin();
        $access_token=$Weixin->access_token($this->appid,$this->secret);
        foreach($imgurl as $v){

            if(stripos($v,'oss-cn') !== false){
                $saveDir= app()->getRootPath().'/public/runtime_wximg/';
                $imgpath= crabImage($v,$saveDir);
                $content_img=$saveDir.$imgpath;
                $content_imgpath=str_replace('\\', '/', $content_img);
            }else{
                $content_img_path= parse_url ($v);
                $content_img =app()->getRootPath().'public'.$content_img_path['path'];
                //$content_img=$content_img_path['path'];
                $content_imgpath=str_replace('\\', '/', $content_img);
            }

            $url = "https://api.weixin.qq.com/cgi-bin/material/add_material?access_token=$access_token&type=image";//上传微信地址和类型
            $result = $this->HttpsUpdateFileServerRequest($url, $content_imgpath);//执行post
            $data_content = json_decode($result, true);//返回值
            if ($data_content['url']!==''){
                $content=str_replace($v,$data_content['url'],$content);

            }
        }

        return $content;


    }


    public function edit(){
        if (request()->isPost()){
            $data=input('post.');
            $content= $data['content'];
            $pic= $data['pic'];


            $add=Db::name('weixin')->where('id',$data['aid'])->update([
                'title'=>$data['title'],
                'author'=>$data['author'],
                'pic'=>$pic,
                'thumb_media_id'=>$data['thumb_media_id'],
                'content_source_url'=>$data['content_source_url'],
                'digest'=>$data['digest'],
                'content'=>$content
            ]);

            return json(['code' => 1, 'data' => $data, 'id' =>$data['id']]);
        }
        $id=input('id');

        $weixin=Db::name('weixin')->where('id',$id)->find();
        if ($weixin['aid']==0){
            $aid=$weixin['id'];
        }else{
            $aid=$weixin['aid'];
        }

        $weixinres=Db::name('weixin')->where('aid','0')->limit(10)->order('id desc')->select();

        $conf= Db::name('conf')->field('web')->order('id desc')->find();
       // View::assign(['weixinres'=>$weixinres,'id'=>$aid,'weixin'=>$weixin]);
        View::assign(['weixinres'=>$weixinres,'id'=>$aid,'weixin'=>$weixin,'conf'=>json_decode($conf['web'],true)]);
        return view();
    }
    //微信发布
    public function wxadd(){

        $Weixin=new \app\admin\model\Weixin();

        $access_token=$Weixin->access_token($this->appid,$this->secret);

        //需要发布文章id
        $id=input('post.');

        $id=implode(',',$id['id']);
        $weixin=Db::name('weixin')->where('id','in',$id)->select()->all();
        $key = array_column(array_values($weixin), 'sort');
        array_multisort($key, SORT_DESC, $weixin);

        $resss=[];
        foreach ($weixin as $k=>$v){
            $desceres=[];
            $ress['title']=$v['title'];
            $ress['author']=$v['author'];
            $ress['thumb_media_id']=$v['thumb_media_id'];
            $ress['content_source_url']=$v['content_source_url'];
            $ress['digest']=cut_str($v['digest'],25);
            $ress['show_cover_pic']=0;
            $ress['content']=$v['content'];
            $resss[]=$ress;
        }

        $tql=array(
            "articles"=>$resss
        );

        $postJson = json_encode($tql,JSON_UNESCAPED_UNICODE);

        //获取用户
        $url="https://api.weixin.qq.com/cgi-bin/media/uploadnews?access_token=$access_token";
        $ress = $this->ch($url,'post','json',$postJson);

        if ($ress['media_id']){
//
            if (Cookie::has('access_token')){
                $accessToken1= Cookie::get('access_token');
            }else{
                $accessToken1=$Weixin->access_token($this->appid,$this->secret);;
            }
            $data=array(
                "filter"=>array("is_to_all"=>true),
                "mpnews"=>array( "media_id"=>$ress['media_id']),
                "msgtype"=>'mpnews'
            );
            //$urlfb="https://api.weixin.qq.com/cgi-bin/message/mass/preview?access_token=$accessToken1";
            $urlfb="https://api.weixin.qq.com/cgi-bin/message/mass/sendall?access_token=$access_token";

            $postfbJson = json_encode($data);
            $resrfb = $this->ch($urlfb, 'post', 'json', $postfbJson);

            if ($resrfb['errcode']=='45028'){
                return json(['code' => 1, 'msg' => '信息发布已达到上限']);
            }
            if ($resrfb['errcode']==0){
                $errcode=json_encode($data);
                Db::name('weixin')->where('id','in',$id)->update(['success'=>$errcode]);
                return json(['code' => 1, 'msg' => '群发信息成功']);
            }else{
                return json(['code' => 0, 'msg' => '群发信息错误']);
                // $this->error('群发信息错误！', 'wxlst', '', 2);
            }
        }


    }
    //ajax动态数据
    public function ajaxadd(){
        $id= input('id');
        $weixinres=Db::name('weixin')->where('id',$id )->select()->all();

        $weires=Db::name('weixin')->where('aid',$id)->select()->all();
        $arr1=array_merge($weixinres,$weires);

        $key = array_column(array_values($arr1), 'sort');
        array_multisort($key, SORT_DESC, $arr1);

        return json(['code' => 1, 'data' => $arr1]);
    }

    //图片上传
    //图片上传
    public function upimg(){
      
        $Weixin=new \app\admin\model\Weixin();
        $access_token=$Weixin->access_token($this->appid,$this->secret);
        $file = request()->file('imgfile');
        $savename = \think\facade\Filesystem::disk('public')->putFile( '/weixin', $file);
        $savename=str_replace('\\', '/', $savename);
        $savename = Upload::img($savename);

        // 获取表单上传文件 例如上传了001.jpg
        $imgpath =app()->getRootPath().'public/static/'.$savename;

        $url = "https://api.weixin.qq.com/cgi-bin/media/upload?access_token=$access_token&type=image";//上传微信地址和类型

        $result = $this->HttpsUpdateFileServerRequest($url, $imgpath);//执行post
        $data = json_decode($result, true);//返回值
        return json(['code' => 1, 'msg' => '上传成功', 'img' => $data['media_id'],'pic'=>'/static/'.$savename]);
    }

    //wxupimg
    public function wxupimg($img){
       $img= GetImage($img);

        $Weixin=new \app\admin\model\Weixin();
        $access_token=$Weixin->access_token($this->appid,$this->secret);

        $url = "https://api.weixin.qq.com/cgi-bin/media/uploadimg?access_token=$access_token";//上传微信地址和类型
        $result = $this->HttpsUpdateFileServerRequest($url, $img);//执行post

        $data = json_decode($result, true);//返回值
return $data;
    }

    private function HttpsUpdateFileServerRequest($url, $path_img)
    {
        $curl = curl_init();
        if (class_exists('\CURLFile')) {
            //php>=5.6版本
            $filedata = array('media' => new \CURLFile(realpath($path_img)));
            curl_setopt($curl, CURLOPT_SAFE_UPLOAD, true);
        } else {
            //php小于5.6版本
            $filedata = array('media' => '@' . $path_img);
            if (defined('CURLOPT_SAFE_UPLOAD')) {
                curl_setopt($curl, CURLOPT_SAFE_UPLOAD, false);
            }
        }
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, FALSE);
        if (!empty ($filedata)) {
            curl_setopt($curl, CURLOPT_POST, 1);
            curl_setopt($curl, CURLOPT_POSTFIELDS, $filedata);
        }
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        $output = curl_exec($curl);
        curl_close($curl);

        return $output;

    }

    private function ch($url, $type = 'get', $res = 'json', $arr = '')
    {

        $ch = curl_init();
        $this_header = array(
            "content-type: application/x-www-form-urlencoded; 
            charset=UTF-8"
        );
        curl_setopt($ch,CURLOPT_HTTPHEADER,$this_header);

        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);

        if ($type == 'post') {
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $arr);
        }

        $cnt = curl_exec($ch);
        if (curl_errno($ch)) {
            return;
        }

        curl_close($ch);

        if ($res == 'json') {
            return json_decode($cnt, true);
        }

        return $cnt;
    }

    //内容页图片上传
    public function file_upload_ueditor(){


        $Weixin=new \app\admin\model\Weixin();
        $access_token=$Weixin->access_token($this->appid,$this->secret);

        // 获取表单上传文件 例如上传了001.jpg
        $file = request()->file('upfile');
        $name=$_FILES['upfile']['name'];
        if ($file) {
            $savename = \think\facade\Filesystem::disk('public')->putFile( '/weixin', $file);

            $imgpath=str_replace('\\', '/', $savename);

            $url = "https://api.weixin.qq.com/cgi-bin/material/add_material?access_token=$access_token&type=image";//上传微信地址和类型
            $result = $this->HttpsUpdateFileServerRequest($url, app()->getRootPath().'public/static/'.$imgpath);//执行post
            $data = json_decode($result, true);//返回值

            $result = [
                'state' => 'SUCCESS',
                'url' => $data['url'],
                'title' => $name,
                'original' => $savename
            ];

            return json($result);
        } else {
            // 上传失败获取错误信息
            return json(['code' => 0, 'msg' => $file->getError()]);
        }


    }


    //获取永久素材
    public function material(){

        $Weixin=new \app\admin\model\Weixin();
        $access_token=$Weixin->access_token($this->appid,$this->secret);
        if (Cookie::has('access_token')){
            $accessToken= Cookie::get('access_token');
        }else{
            $accessToken=$Weixin->access_token($this->appid,$this->secret);;
        }
        if ($accessToken=='0'){
            return json(['code' => 0, 'msg' => '微信请求次数以达到上线']);
        }
//微信请求次数以达到上线
        $url="https://api.weixin.qq.com/cgi-bin/material/batchget_material?access_token=$accessToken";

        $isonurl = file_get_contents($url);

        $data=array(
            'type'=>'image',
            'offset'=>'0',
            'count'=>'20'
        );

        $postJson = json_encode($data,JSON_UNESCAPED_UNICODE);
        $material = $this->ch($url,'post','json',$postJson);

        View::assign(['material'=>$material['item']]);
        return view();

    }



    //查询菜单接口
    public function catelist(){

        $Weixin=new \app\admin\model\Weixin();
        $access_token=$Weixin->access_token($this->appid,$this->secret);

        if (Cookie::has('access_token')){
            $accessToken= Cookie::get('access_token');
        }else{
            $accessToken=$Weixin->access_token($this->appid,$this->secret);;
        }
        $url="https://api.weixin.qq.com/cgi-bin/get_current_selfmenu_info?access_token=$accessToken";
        $ison = file_get_contents($url);
        $result = json_decode($ison, true);
        dump($result);die;
    }

    //创建菜单
    public function cateadd(){
        if (request()->isPost()){
            $data=input('data');

            $data_json=json_encode($data['menu'],JSON_UNESCAPED_UNICODE);


            $Weixin=new \app\admin\model\Weixin();
            $access_token=$Weixin->access_token($this->appid,$this->secret);
            if (Cookie::has('access_token')){
                $accessToken= Cookie::get('access_token');
            }else{
                $accessToken=$Weixin->access_token($this->appid,$this->secret);;
            }

            $urlfb="https://api.weixin.qq.com/cgi-bin/menu/create?access_token=$accessToken";//测试账号

            $result =$this-> https_request($urlfb, $data_json);

            $cate = json_decode($result, true);

            if($cate['errcode']==0){
                return json(['code' => 1, 'msg' => '创建菜单成功']);
            }else{
                return json(['code' => 0, 'msg' => '创建菜单失败']);
            }
        }

        $Weixin=new \app\admin\model\Weixin();
        $access_token=$Weixin->access_token($this->appid,$this->secret);

        if (Cookie::has('access_token')){
            $accessToken= Cookie::get('access_token');
        }else{
            $accessToken=$Weixin->access_token($this->appid,$this->secret);;
        }
        $url="https://api.weixin.qq.com/cgi-bin/get_current_selfmenu_info?access_token=$accessToken";

        $ison = file_get_contents($url);
        $cate = json_decode($ison, true);

        if ($cate['is_menu_open']==0){
            View::assign(['cate'=>'']);
        }else{
            View::assign(['cate'=>$cate['selfmenu_info']['button']]);
        }

//
//        View::assign(['cate'=>$cate['selfmenu_info']['button']]);
        return view();
    }

    public function  https_request($url,$data = null){
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, FALSE);
        if (!empty($data)){
            curl_setopt($curl, CURLOPT_POST, 1);
            curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
        }
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        $output = curl_exec($curl);
        curl_close($curl);
        return $output;
    }

    //删除
    public function delimg($url="",$thumb_media_id=''){

        if ($url!=="" || !empty($url)){
            $file=app()->getRootPath().'public'.$url;
            if (file_exists($file)){
                $file=unlink($file);
                if ($file){
                    return json(['code'=>1,'msg'=>'删除成功']);
                }
                return json(['code'=>0,'msg'=>'删除失败']);
            }
        }
    }
    public function del($id){
        $del=Db::name('weixin')->delete($id);
        if($del){
            // $this->success('删除栏目成功！',url('lst'));
            return json(['code'=>1,"msg"=>'删除成功']);
        }else{
            //$this->error('删除栏目失败！');
            return json(['code'=>1,"msg"=>'删除失败!']);
        }
    }
    public function wxdel($id){
        $weixin=Db::name('weixin')->find($id);
        if ($weixin['success']==''){
            return $this->del($id);
        }
        $data=json_decode($weixin['success'],true);
        $Weixin=new \app\admin\model\Weixin();
        $access_token=$Weixin->access_token($this->appid,$this->secret);
        $url="https://api.weixin.qq.com/cgi-bin/message/mass/delete?access_token=$access_token";
        $data=array(
            'msg_id'=>$data['msg_id'],
            'article_idx'=>'0'
        );
        $postJson = json_encode($data,JSON_UNESCAPED_UNICODE);
        $material = $this->ch($url,'post','json',$postJson);
        if ($material['errcode']==0){
            return $this->del($id);
        }
    }

    public function paiban($id='title'){
       $data= config("$id");
        View::assign([
            'data'=>$data
        ]);
        return view();
    }

    public function sort(){
        if (request()->isPost()){
            $data=input('post.');

            if ($data['sort']=='up'){
                $weixin=Db::name('weixin')->where('id',$data['id'])->inc('sort',1)->update();
            }else{
                $weixin=Db::name('weixin')->where('id','=',$data['id'])->inc('sort',-1)->update();
            }
        }
    }

}