<?php
/**
 * Created by PhpStorm.
 * User: HP
 * Date: 2022/3/15
 * Time: 13:02
 */

namespace app\admin\model;

use think\facade\Db;
use think\Model;
use think\facade\Config;

//导入数据
use PhpOffice\PhpSpreadsheet\Cell\Coordinate;
use PhpOffice\PhpSpreadsheet\IOFactory;
class Archives extends Model
{

    //导入数据
    public static function GetDaoRu(){

        $info=app()->getRootPath().'public/archives.xlsx';


        $fileExtendName = substr(strrchr($info, '.'), 1);
        if ($fileExtendName == 'xlsx') {
            $objReader = IOFactory::createReader('Xlsx');
        } else {
            $objReader =IOFactory::createReader('Xls');
        }
        // 设置文件为只读
        $objReader->setReadDataOnly(TRUE);
        $objPHPExcel=$objReader->load($info);

        $sheets = $objPHPExcel->getAllSheets();
        $sheets_count = count($sheets);


        //excel中的第一张sheet
        $sheet = $objPHPExcel->getSheet(0);
        // 取得总行数
        $highestRow = $sheet->getHighestRow();
        // 取得总列数
        $highestColumn = $sheet->getHighestColumn();
        Coordinate::columnIndexFromString($highestColumn);
        $lines = $highestRow - 1;

        if ($lines <= 0) {
            echo('数据不能为空！');
            exit();
        }
        // 直接取出excle中的数据
        $data = $objPHPExcel->getActiveSheet()->toArray();
        // 删除第一个元素（表头）
        array_shift($data);

        return $data;



    }

    public static function Getresarr($data,$postdata){

        foreach ($postdata as $k=>$v){
            if ($v!=''){
                $arr[$k]=$data[$v];
            }

        }
       return $arr;
    }

    public static function LstSelect($limit,$curr,$data=''){

        $where='';
        $data=array_filter($data);

        unset($data['page'],$data['limit']);

        if (isset($data['status'])){
            $data['status']=$data['status']-1;
        }
        foreach ($data as $k=>$v){

            if ($k=='title'){
                $where.=' AND a.title LIKE "%'.$data['title'].'%"';
            }
            if ($k=='select'){
                $where=' AND  b.cate_id IN('.$data['select'].')';
            }
            if ($k=='status'){
                $where.=' AND  a.status = '.$data['status'];
            }
            if ($k=='timestart'){
                $where.=' AND a.time > '.strtotime($data['timestart'].' 00:00:00' );
            }
            if ($k=='timeend'){
                $where.=' AND a.time < '.strtotime($data['timeend'].' 24:00:00');
            }
        }
      
        $where= substr($where,5);

        //$where='';
//        if (isset($data['select'])){
//            $where='b.cate_id IN('.$data['select'].')';
//        }else if (isset($data['title']) ){
//            $where.=' AND a.title LIKE "%'.$data['title'].'%"';
//        }else if(isset($data['status'])){
//            $where.='  AND  a.status = '.$data['status'];
//        }else if(isset($data['timestart']) && isset($data['timeend'])){
//            $where.=' AND a.time > '.strtotime($data['timestart']);
//            $where.=' AND a.time < '.strtotime($data['timeend']);
//        }

        if ($where!==''){
            $artRes= Db::name('archives')
                ->alias('a')
                ->join('archives_id b','a.id=b.aid')
                ->join('arc_cate c','c.id=b.cate_id')
                ->where($where)->group('a.id')
                ->field('a.*,b.cate_id,c.cate_name')
                ->withAttr('time',function ($value){
                    return date('Y-m-d', $value);
                })
                ->withAttr('attr_time',function ($value){
                    if ($value==0){
                        return 0;
                    }else{
                        return date('Y-m-d', $value);
                    }
                })
                ->withAttr('attr',function ($value){
                    $status = [0=>'图文',1=>'图片集',2=>'外部链接',3=>'视频集',4=>'资源下载'];
                    return $status[$value];
                })
                ->withAttr('status',function ($value){
                    $status = [1=>'已审核',0=>'待审核'];
                    return $status[$value];
                })->order('a.id desc,a.attr_time desc,a.time desc')
                ->select()->toArray();
        }else{
            $artRes= Db::name('archives')
                ->alias('a')
                ->join('archives_id b','a.id=b.aid')
                ->join('arc_cate c','c.id=b.cate_id')
                ->group('a.id')
                ->field('a.*,b.cate_id,c.cate_name')
                ->withAttr('time',function ($value){
                    return date('Y-m-d', $value);
                })
                ->withAttr('attr_time',function ($value){
                    if ($value==0){
                        return 0;
                    }else{
                        return date('Y-m-d', $value);
                    }
                })
                ->withAttr('attr',function ($value){
                    $status = [0=>'图文',1=>'图片集',2=>'外部链接',3=>'视频集',4=>'资源下载'];
                    return $status[$value];
                })
                ->withAttr('status',function ($value){
                    $status = [1=>'已审核',0=>'待审核'];
                    return $status[$value];
                })->order('a.id desc,a.attr_time desc,a.time desc')
                ->select()->toArray();
        }




        // $artRes= self::where($where)->order('sort desc,time desc,id desc ')->select()->toArray();

        $currpage =page_array($artRes, $limit, $curr);

        $data = [
            "status" => 200,
            "hint" => "无数据",
            "total" => count($artRes),
            "rows" => $currpage['data']
        ];
        if (count($currpage['data']) > 0) {
            $data['msg'] = 'OK';
            $data['status'] = 200;
        } else {
            $data['msg'] = "无数据";
            $data['status'] = 200;
        }

        return $data;
    }

    public static function shield($data){
        $shield=Config::get('shield.name');
        $shield=  explode(',',$shield);
        $badword1 = array_combine($shield,array_fill(0,count($shield),'***'));
        $str = strtr($data, $badword1);
        return $str;
    }

    public static function GetAdd($data){


        $_data['title']=self::shield($data['title']);
        $_data['url']=isset($data['url'])?$data['url']:'';
        $_data['keywords']=isset($data['keywords'])?self::shield($data['keywords']):'';
        $_data['description']=isset($data['description'])?self::shield($data['description']):'';
        $_data['writer']=isset($data['writer'])?self::shield($data['writer']):'';
        $_data['source']=isset($data['source'])?self::shield($data['source']):'';
        $_data['arr_status']=isset($data['arr_status'])?$data['arr_status']:'1';

        if (isset($data['test-editor-html-code'])){
            $add['doc'] =self::shield($data['test-editor-markdown-doc']);
            $add['html']=self::shield($data['test-editor-html-code']);
            $_data['content']=json_encode($add);
            $_data['markdown']='markdown';
        }else{
            $_data['content']=isset($data['content'])?self::shield($data['content']):'';
        }

        $_data['model_id']=isset($data['model_id'])?$data['model_id']:'';
        $_data['attr']=$data['attr'];
        $_data['status']=isset($data['status'])?$data['status']:'0';
        $_data['time']=time();
        if (isset($data['img']) && $data['img']!==''){
            $_data['litpic']=1;
        }
        if (isset($data['titlearr'])){
            if ($data['attr']!=='3'){
                for ($i=0;$i<count($data['titlearr']);$i++){
                    $_da[$i]['titlearr']=self::shield($data['titlearr'][$i]);
                    $_da[$i]['imgarr']=$data['imgarr'][$i];

                }
            }else{
                for ($i=0;$i<count($data['titlearr']);$i++){
                    $_da[$i]['titlearr']=self::shield($data['titlearr'][$i]);
                    $_da[$i]['imgtitle']=self::shield($data['imgtitle'][$i]);
                    $_da[$i]['imgarr']=$data['imgarr'][$i];
                }
            }

            $_data['imgres']=json_encode($_da);
        }


        $id=  Db::name('archives')->insertGetId($_data);

        if ($data['select']){
            self::getselect($id,$data['select']);
        }
        if ($data['img']){

            $add=self::getimg($id,$data['img']);
        }
        return true;
    }

    public static function Getedit($data){

        $_data['title']=self::shield($data['title']);
        $_data['url']=isset($data['url'])?$data['url']:'';
        $_data['keywords']=isset($data['keywords'])?self::shield($data['keywords']):'';
        $_data['description']=isset($data['description'])?self::shield($data['description']):'';
        $_data['writer']=isset($data['writer'])?self::shield($data['writer']):'';
        $_data['source']=isset($data['source'])?self::shield($data['source']):'';
        $_data['arr_status']=isset($data['arr_status'])?$data['arr_status']:'1';
        if (isset($data['test-editor-html-code'])){

            $add['doc'] =self::shield($data['test-editor-markdown-doc']);
            $add['html']=self::shield($data['test-editor-html-code']);
            $_data['content']=json_encode($add);
            $_data['markdown']='markdown';
        }else{
            $_data['content']=isset($data['content'])?self::shield($data['content']):'';
        }
        $_data['model_id']=isset($data['model_id'])?$data['model_id']:'';
        $_data['attr']=isset($data['attr'])?$data['attr']:'';
        $_data['status']=isset($data['status'])?$data['status']:'0';
        if (isset($data['img']) && $data['img']!==''){
            $_data['litpic']=1;
        }else{
            $_data['litpic']=0;
            Db::name('pics')->where('aid','=',$data['id'])->delete();//删除全部封面图
        }

        if (isset($data['titlearr'])){
            if ($data['attr']!=='3'){
                for ($i=0;$i<count($data['titlearr']);$i++){
                    $_da[$i]['titlearr']=self::shield($data['titlearr'][$i]);
                    $_da[$i]['imgarr']=$data['imgarr'][$i];

                }
            }else{
                for ($i=0;$i<count($data['titlearr']);$i++){
                    $_da[$i]['titlearr']=self::shield($data['titlearr'][$i]);
                    $_da[$i]['imgtitle']=self::shield($data['imgtitle'][$i]);
                    $_da[$i]['imgarr']=$data['imgarr'][$i];
                }
            }

            $_data['imgres']=json_encode($_da);
        }





        Db::name('archives')->where('id','=',$data['id'])->update($_data);
        if ($data['select']){
            self::editselect($data['id'],$data['select']);
        }
        if ($data['img']!==''){
            $add=self::getimg($data['id'],$data['img']);
        }
        return true;
    }
    public static function getimg($id,$img){

        Db::name('pics')->where('aid','=',$id)->delete();
        $cate_id=explode(',',$img);//栏目id
        foreach ($cate_id as $k=>$v){
            $arr[$k]['pic']=$v;
            $arr[$k]['aid']=$id;
            $arr[$k]['sort']=$k;
        }
        $add=  Db::name('pics')->insertAll($arr);


    }
    public static function getselect($id,$select){
        $cate_id=explode(',',$select);//栏目id
        foreach ($cate_id as $k=>$v){
            $arr[$k]['cate_id']=$v;
            $arr[$k]['aid']=$id;
        }
        $add=  Db::name('archives_id')->insertAll($arr);
        if ($add){
            return true;
        }else{
            return false;
        }
    }
    public static function editselect($id,$select){
        $product_id=  Db::name('archives_id')->where('cate_id','NOT IN',$select)->where('aid','=',$id)->delete();
        $cate_id=explode(',',$select);//栏目id
        foreach ($cate_id as $k=>$v){
            $product_id= Db::name('archives_id')->where('cate_id','=',$v)->where('aid','=',$id)->find();
            if (!$product_id){
                $arr['cate_id']=$v;
                $arr['aid']=$id;
                Db::name('archives_id')->insert($arr);
            }
        }
        return true;
    }

    //清楚缓存
    public function runtime($runtime){

       // $runtime=$this->confgroup().'/runtime/';

        if (delete_dir_file($runtime)) {
            return json(['code'=>1,"msg"=>'清除缓存成功']);
        } else {
            return json(['code'=>0,"msg"=>'清除缓存失败']);
        }
    }


}