<?php
/**
 * 快递投放
 * User: HP
 * Date: 2022/4/1
 * Time: 15:17
 * 快递
 */

namespace app\admin\model;

use think\facade\Db;
use think\Model;
use think\facade\Cookie;
class Express extends Model
{


    //下单
    protected $name='pay';
    public function add($id,$delivery_id,$biz_id,$expect_time){
       $data_id= Db::name('pay') ->withAttr('content', function ($value) {
           return json_decode($value,true);
       })->find($id);

      $address=  json_decode($data_id['address'],true);

        $access_token=$this->jscode2session();

        $access_token= $access_token['access_token'];

        //预约上面取件收件
        if ($expect_time==''){
            $expecttime=0;
        }else{
            $expecttime=strtotime($expect_time);
        }

        //获取快递运单公司
//        $api="https://api.weixin.qq.com/cgi-bin/express/business/delivery/getall?access_token=$access_token";
//        $appid=file_get_contents($api);


        //订单内容  直接购买
        if($data_id['attr']==0){
            $pay= Db::name('pay')->where('out_trade_no','in',$data_id['out_trade_no'])
                ->withAttr('content', function ($value) {
                    return json_decode($value,true);
                })->select()->all();


            $detail_list=[];
            $cargo_detail_list=[];
            foreach ($pay as $k=>$v){

                $description=cut_str($v['description'],'20');
                $goods_img_url=isset($v['content']['product_size'])&& isset($v['content']['product_size']['img']) && $v['content']['product_size']['img']!==''?$v['content']['product_size']['img']:$v['content'][0]['img'];

                $num="购买".$v['num']."件";
                $detail_list[]=[
                    "goods_name"=> "$description",
                    "goods_img_url"=>"$goods_img_url",
                    "goods_desc"=> "$num"
                ];
                $cargo_detail_list[]=[
                    "name"=> "$description",
                    "count"=>1
                ];
            }
        }else{

            $detail_list=[];
            $cargo_detail_list=[];
            foreach ($data_id['content'] as $k=>$v){

                $description=cut_str($v['product']['item_name'],'20');
                $goods_img_url=$v['product_size']!==''&& isset($v['product_size']['img']) && $v['product_size']['img']!==''?$v['product_size']['img']:isset($v['product']['img'][0]) && $v['product']['img'][0]!==''?$v['product']['img'][0]:$v['product']['img'];
                $num="";
                $detail_list[]=[
                    "goods_name"=> "$description",
                    "goods_img_url"=>"$goods_img_url",
                    "goods_desc"=> "$num"
                ];
                $cargo_detail_list[]=[
                    "name"=> "$description",
                    "count"=>1
                ];
            }
        }

        //获取发快递地址
        $confmerchant=Db::name('conf')->find(1);

        $merchant=json_decode($confmerchant['merchant'],true);

        $uname=Cookie::get('uname');//发快递人姓名
        $mchnt_notify_mobile=$merchant['mchnt_notify_mobile'];//发快递电话
        $company=$merchant['company'];//发件人公司名称

        $city=explode('/',$merchant['city']);//省市区
        $mchnt_address=$merchant['mchnt_address'];//详地址


        //生成运单
        $urlapi="https://api.weixin.qq.com/cgi-bin/express/business/order/add?access_token=$access_token";
        $out_trade_no = date('YmdHis', time()) . rand(1000, 9999);
        $name=$address['name'];
        $phone=$address['phone'];
        $address_arr= explode('-',$address['address']);
        $detail=$address['detail'];

        //发件人信息
        $sender=[
            "name"=>"$uname",
            "tel"=>"",
            "mobile"=>"$mchnt_notify_mobile",
            "company"=>"",
            "post_code"=>"",
            "country"=>"中国",
            "province"=> "$city[0]",
            "city"=>"$city[1]",
            "area"=> "$city[2]",
            "address"=> "$mchnt_address"

        ];

        //收件人信息
        $receiver=[
            "name"=>"$name",
            "tel"=>"",
            "mobile"=>"$phone",
            "company"=>"",
            "post_code"=>"",
            "country"=>"中国",
            "province"=> "$address_arr[0]",
            "city"=>"$address_arr[1]",
            "area"=> "$address_arr[2]",
            "address"=> "$detail"
        ];
        $data=[
            "add_source"=>0,
            "order_id"=>"$out_trade_no",
            "openid"=>"o5S-q5f5TxOKZVZmVuXFwhg3USmg",
            "delivery_id"=>"$delivery_id",
            "biz_id"=>"$biz_id",
            "custom_remark"=>"物流助手",
            "sender"=>$sender,
            "receiver"=>$receiver,
            "shop"=>[
                "wxa_path"=> "/index/index?from=waybill&id=01234567890123456789",
                "detail_list"=>$detail_list
            ],
            "cargo"=>[
                "count"=> 1,
                "weight"=> 5.5,
                "space_x"=> 30.5,
                "space_y"=> 20,
                "space_z"=>20,
                "detail_list"=>$cargo_detail_list
            ],
            "insured"=>[
                "use_insured"=> 0,
                "insured_value"=> 0
            ],
            "service"=> [
                "service_type"=> 1,
                "service_name"=> "test_service_name"
            ],
            "expect_time"=>"$expecttime"
        ];


        $data = json_encode($data,JSON_UNESCAPED_UNICODE);
        $_data_array=$this->httpRequest($urlapi,$data,'POST');

        $_dataarray=json_decode($_data_array,true);

        if ($_dataarray['errmsg']=='ok'){
            Db::name('pay')->where('out_trade_no','in',$data_id['out_trade_no'])->update(['kuaidihao'=>$_dataarray['order_id'],'waybill_data'=>$_data_array,'status'=>2,'kuaidihao_time'=>time()]);
            return json(['code'=>1,"msg"=>'订单成功']);
        }else{
            return json(['code'=>0,"msg"=>'订单失败']);
        }
      
    }

    //取消订单

    public function cancel($id,$data){
        $access_token=$this->jscode2session();

        $access_token= $access_token['access_token'];
        $url='https://api.weixin.qq.com/cgi-bin/express/business/order/cancel?access_token='.$access_token;

        $order_id=$data['order_id'];
        $delivery_id=$data['waybill_data'][0]['key'];
        $waybill_id=$data['waybill_id'];
        $data=[
            "order_id"=>"$order_id",
            "openid"=>"o5S-q5f5TxOKZVZmVuXFwhg3USmg",
            "delivery_id"=>"TEST",
            "waybill_id"=>"$waybill_id"
        ];
        $data = json_encode($data);

        $_dataarray=$this->httpRequest($url,$data,'POST');

        $_data=json_decode($_dataarray,true);

        if ($_data['errmsg']=='ok'){
            $pay=Db::name('pay')->find($id);
            Db::name('pay')->where('out_trade_no','in',$pay['out_trade_no'])->update(['status'=>1]);
            return json(['code'=>1,"msg"=>'取消订单成功']);
        }else{
            return json(['code'=>0,"msg"=>'取消订单失败']);
        }


    }


    protected function jscode2session(){

        // $url="https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid=wx870ceef75e00dd24&secret=f6125604766cab2273b576e8f46b4c15";
        $conf=Db::name('conf')->order('id desc')->find();
        $confRes=json_decode($conf['weixin'],true);
        $url="https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid={$confRes['appid']}&secret={$confRes['appSecret']}";
        $appid=file_get_contents($url);
        return json_decode($appid,true);
    }
    //获取快递运单公司
    public function getall(){
        $access_token=$this->jscode2session();
        $access_token= $access_token['access_token'];
        $api="https://api.weixin.qq.com/cgi-bin/express/business/delivery/getall?access_token=$access_token";
        $appid=$this->httpRequest($api,'','GET');
        return json_decode($appid,true);
    }

    //获取订单动态
    public function express($id){
        $access_token=$this->jscode2session();
        $access_token= $access_token['access_token'];

        $api="https://api.weixin.qq.com/cgi-bin/express/business/path/get?access_token=$access_token";
        $pay= Db::name('pay') ->withAttr('waybill_data', function ($value) {
            return json_decode($value,true);
        })->where('kuaidihao','=',$id)->find();
     
       $order_id= $pay['waybill_data']['order_id'];
       $waybill_id=$pay['waybill_data']['waybill_id'];
        $data=[
            "order_id"=> "$order_id",
            "openid"=> "o5S-q5f5TxOKZVZmVuXFwhg3USmg",
            "delivery_id"=> "TEST",
            "waybill_id"=> "$waybill_id",
            "print_type"=>0
        ];
        $data = json_encode($data);
        $_data_array=$this->httpRequest($api,$data,'POST');
        return json_decode($_data_array,true);
    }

    protected  function httpRequest($url, $data='', $method='GET'){
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($curl, CURLOPT_AUTOREFERER, 1);
        if($method=='POST')
        {
            curl_setopt($curl, CURLOPT_POST, 1);
            if ($data != '')
            {
                curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
            }
        }
        curl_setopt($curl, CURLOPT_TIMEOUT, 30);
        curl_setopt($curl, CURLOPT_HEADER, 0);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        $result = curl_exec($curl);
        curl_close($curl);
        return $result;
    }

    //同城配送 获取同城配送公司
    public function GetPreAdd(){
        $access_token=$this->jscode2session();
        $access_token= $access_token['access_token'];
        //$api="https://api.weixin.qq.com/cgi-bin/express/local/business/delivery/getall?access_token=$access_token";
        $api="https://api.weixin.qq.com/cgi-bin/express/local/business/open?access_token=$access_token";
        $appid=$this->httpRequest($api,'','POST');

        return json_decode($appid,true);
    }

    //同城配送单
    public function PreAdd($id,$shopid,$biz_id,$expect_time){

        $access_token=$this->jscode2session();
        $access_token= $access_token['access_token'];
      //  $api="https://api.weixin.qq.com/cgi-bin/express/local/business/order/pre_add?access_token=$access_token";
        $api="https://api.weixin.qq.com/cgi-bin/express/local/business/order/add?access_token=$access_token";
        $data_id= Db::name('pay') ->withAttr('content', function ($value) {
            return json_decode($value,true);
        })->find($id);


        //订单内容  直接购买
        $pay= Db::name('pay')->where('out_trade_no','in',$data_id['out_trade_no'])
            ->withAttr('content', function ($value) {
                return json_decode($value,true);
            })->select()->all();
        $amount= Db::name('pay')->where('out_trade_no','in',$data_id['out_trade_no'])->sum('amount');


        $goods=[];

        foreach ($pay as $k=>$v){


            $description=cut_str($v['description'],'20');

            if (isset($v['content']['product_size']) && $v['content']['product_size']!==''){
                $good_unit=$v['content']['product_size']['shipment'];
            }else{
                $good_unit=$v['content']['product']['price'];
            }

            $goods[]=[
                "good_count"=>$v['num'],
                "good_name"=> "$description",
                "good_price"=> $good_unit,
                "good_unit"=> "元"
            ];

        }


        $address=  json_decode($data_id['address'],true);
        $name=$address['name'];
        $phone=$address['phone'];
        $address_arr= explode('-',$address['address']);
        $detail=$address['detail'];
        $shop_order_id = date('YmdHis', time()) . rand(1000, 9999);
        $poi_seq=date('YmdHi', time()) . rand(1000, 9999);


        //获取发快递地址
        $confmerchant=Db::name('conf')->find(Cookie::get('uid'));
        $merchant=json_decode($confmerchant['merchant'],true);
        $lat=$merchant['address_latitude'];
        $lng=$merchant['address_longitude'];
        $uname=Cookie::get('uname');//发快递人姓名
        $mchnt_notify_mobile=$merchant['mchnt_notify_mobile'];//发快递电话
        $company=$merchant['company'];//发件人公司名称
        $city=explode('/',$merchant['city']);//省市区
        $mchnt_address=$merchant['mchnt_address'];//详地址

        //发件人信息
        $sender=[
            "name"=>"$uname",
            "tel"=>"",
            "phone"=>"$mchnt_notify_mobile",
            "city"=>"$city[1]",
            "address_detail"=> "$city[2]",
            "address"=> "$mchnt_address",
            "coordinate_type"=> 0,
            "lat"=> $lat,
            "lng"=> $lng,
        ];
        //收件人信息
        $receiver=[
            "name"=>"$name",
            "tel"=>"",
            "phone"=>"$phone",
            "city"=>"$address_arr[1]",
            "address_detail"=> "$address_arr[2]",
            "address"=> "$detail",
            "coordinate_type"=> 0,
            "lat"=> 32.09586,
            "lng"=> 112.125416,
        ];

        $cargo=[
            "cargo_first_class"=> "美食夜宵",
            "cargo_second_class"=> "快餐/地方菜",
            "goods_detail"=>[
                "goods"=>$goods
            ],
            "goods_height"=> 15,//货物高度
            "goods_length"=> 30,//货物长度
            "goods_value"=> $amount,//货物价格
            "goods_weight"=> 0.5,//货物重量
            "goods_width"=> 15//货物宽度
        ];
        $order_info=[
            "delivery_service_code"=> "",
            "expected_delivery_time"=> $data_id['expected_delivery_time'],
            "is_direct_delivery"=> 0,
            "is_finish_code_needed"=>1,
            "is_insured"=> 0,
            "is_pickup_code_needed"=> 1,
            "note"=> "test_note",
            "order_time"=>$data_id['time'],
            "order_type"=> 0,
            "poi_seq"=> "$poi_seq",
            "tips"=> 0
        ];
       $goods_name= cut_str($pay[0]['description'],'20');
        $shop=[
            "goods_count"=> count($pay),
            "goods_name"=> "$goods_name",
            "img_url"=> "https://mmbiz.qpic.cn/mmbiz_png/xxxxxxxxx/0?wx_fmt=png",
            "wxa_path"=> "/page/index/index"
        ];
        $data=[
            "cargo"=>$cargo,
            "shopid"=>"test_shop_id",
            "shop_order_id"=>"$shop_order_id",
            "shop_no"=>"test_shop_id",
            "delivery_sign"=>"12345678",
            "delivery_sign"=> "01234567890123456789",
            "delivery_id"=>"TEST",
            "openid"=>"o5S-q5f5TxOKZVZmVuXFwhg3USmg",
            "sender"=>$sender,
            "receiver"=>$receiver,
            "order_info"=>$order_info,
            "shop"=>$shop

        ];
        //202205231014543563_waybillid
      //  {"resultcode":0,"resultmsg":"","fee":10,"delivery_token":"test_delivery_token","dispatch_duration":300}"
      $data = json_encode($data,JSON_UNESCAPED_SLASHES|JSON_UNESCAPED_UNICODE);

        $_data_array=$this->httpRequest($api,$data,'POST');
        dump($_data_array);die;
        $_dataarray=json_decode($_data_array,true);

        if ($_dataarray['resultmsg']=='ok'){
            Db::name('pay')->where('out_trade_no','in',$data_id['out_trade_no'])->update(['waybill_data'=>$_data_array,'status'=>2,'kuaidihao_time'=>time(),'kuaidihao'=>$_dataarray['waybill_id']]);
            return json(['code'=>1,"msg"=>'订单成功']);
        }else{
            return json(['code'=>0,"msg"=>'订单失败']);
        }

        return $_dataarray;

    }
    //同城配送单 取消
    public function paycancel($id){
        $_data=  Db::name('pay')->find($id);

        $access_token=$this->jscode2session();
        $access_token= $access_token['access_token'];
        $api="https://api.weixin.qq.com/cgi-bin/express/local/business/order/cancel?access_token=$access_token";
        $shop_order_id = date('YmdHis', time()) . rand(1000, 9999);
       // $waybill_id=substr($_data['kuaidihao'],0,strrpos($_data['kuaidihao'] ,"_"));;
       $waybill_id=$_data['kuaidihao'];
        $data=[
            "shopid"=>"test_shop_id",
            "shop_order_id"=>"$shop_order_id",
            "waybill_id"=>"$waybill_id",
            "delivery_id"=>"TEST",
            "cancel_reason_id"=> "1",
            "cancel_reason"=>"",
            "delivery_sign"=>"01234567890123456789",
            "shop_no"=>"test_shop_id",

        ];
        $data = json_encode($data);

        $_data_array=$this->httpRequest($api,$data,'POST');
        $_dataarray=json_decode($_data_array,true);

        if (isset($_dataarray['resultmsg']) && $_dataarray['resultmsg']=='ok'){
            Db::name('pay')->where('out_trade_no','in',$_data['out_trade_no'])->update(['waybill_data'=>'订单取消','status'=>1,'kuaidihao_time'=>'','kuaidihao'=>'']);
            return json(['code'=>1,"msg"=>'订单成功']);
        }else{

            return json(['code'=>0,"msg"=>errcode($_dataarray['errcode'])]);
        }
    }

    public function test_update_order(){
//        $access_token=$this->jscode2session();
//        $access_token= $access_token['access_token'];
//        $api="https://api.weixin.qq.com/cgi-bin/express/local/business/test_update_order?access_token=$access_token";
//
//        $data=[
//            "shopid"=> "test_shop_id",
//            "shop_order_id"=> "202206151648537245",
//            "action_time"=> time(),
//            "order_status"=> 301,
//            "action_msg"=> "",
//        ];
//
//        $data = json_encode($data);
//
//        $_data_array=$this->httpRequest($api,$data,'POST');
//        $_dataarray=json_decode($_data_array,true);
//return $_dataarray;

        $access_token=$this->jscode2session();
        $access_token= $access_token['access_token'];


        $api="https://api.weixin.qq.com/cgi-bin/express/business/test_update_order?access_token=$access_token";

        $data=[
            "biz_id"=> "test_biz_id",
            "order_id"=> "202209251649373928",
            "delivery_id"=> "TEST",
            "waybill_id"=> "202209251649373928_waybill_id",
            "action_time"=> time(),
            "action_type"=>300003,
           // 'action_msg'=>"快递【上海】发文【上海】"
           // "action_msg"=>"投递员:张建强,电话:19371778563 风雨兼程送快递，只盼小主能满意。请点击“服务评价”反馈您的感受，助力EMS不断提升服务水平"
            //快件已到达 襄阳 集散中心，准备发往樊城集散中心
            'action_msg'=>'他人代收：门卫室,投递员:张建强,电话:19371778563 风雨兼程送快递，只盼小主能满意。请点击“服务评价”反馈您的感受，助力EMS不断提升服务水平'
        ];

        $data = json_encode($data,JSON_UNESCAPED_SLASHES|JSON_UNESCAPED_UNICODE);

        $_data_array=$this->httpRequest($api,$data,'POST');
dump($_data_array);die;
    }

    //获取同城配送单信息
    public function getorderget($id){

        $_data=  Db::name('pay')->find($id);
        $access_token=$this->jscode2session();
        $access_token= $access_token['access_token'];
        $api="https://api.weixin.qq.com/cgi-bin/express/local/business/order/get?access_token=$access_token";
        $shop_order_id = date('YmdHis', time()) . rand(1000, 9999);
        $kuaidihao=substr($_data['kuaidihao'],0,strrpos($_data['kuaidihao'] ,"_"));;
        $data=[
            "shopid"=> "test_shop_id",
            "shop_order_id"=> "$kuaidihao",
            "shop_no"=> "test_shop_id",
            "delivery_sign"=> $shop_order_id,
        ];
        $data = json_encode($data);

        $_data_array=$this->httpRequest($api,$data,'POST');
        $_dataarray=json_decode($_data_array,true);
        if ($_dataarray['resultmsg']=='ok'){
            return json(['code'=>1,"msg"=>order_status($_dataarray['order_status'])]);
        }
        return json(['code'=>0,"msg"=>"查询失败"]);

    }

}