<?php
/**
 * Created by PhpStorm.
 * User: pc
 * Date: 2021/4/8
 * Time: 11:08
 */

namespace app\admin\model;

use think\facade\Db;
use think\Model as Modela;
use app\admin\validate\Model as ModelValidate;
use think\exception\ValidateException;
class Model extends Modela
{

    public  function getlist($limit,$page){

        $modelres=self::order('id desc')->select();

        $modelres=$modelres->toArray();


        $currpage =page_array($modelres, $limit, $page);
        $data = [
            "status" => 200,
            "hint" => "无数据",
            "total" => count($modelres),
            "rows" => $currpage['data']
        ];
        if (count($currpage['data']) > 0) {
            $data['msg'] = 'OK';
            $data['status'] = 200;
        } else {
            $data['msg'] = "无数据";
            $data['status'] = 200;
        }
        return $data;
    }
    public function getadd($data){
        try {
            $result =  validate(ModelValidate::class)->scene('add')->check($data);

        } catch (ValidateException $e) {
            // 验证失败 输出错误信息

            return returnjson(0,$e->getError());
        }
        $data['model_name'] = strip_tags($data['model_name']);

        $add=self::insert($data);
        if($add){
            $tableName=$data['table_name'];
            $tableName=config("database.connections.mysql.prefix").$tableName;
            $sql="create table {$tableName} (id mediumint(8) unsigned not null , PRIMARY KEY (`id`)) engine=MYISAM default charset=utf8";
            Db::execute($sql);

            return returnjson(1,'添加模型成功');
        }else{
            return returnjson(0,'添加模型失败');
        }
    }

    public function getedit($data){
        try {
            $result =  validate(ModelValidate::class)->scene('edit')->check($data);
        } catch (ValidateException $e) {
            // 验证失败 输出错误信息

            return returnjson(0,$e->getError());
        }
        
        $data['model_name'] = strip_tags($data['model_name']);
        $oldTableName=self::field('table_name')->find($data['id']);
        $oldTableName=$oldTableName['table_name'];

        $save=self::update($data);

        if($oldTableName != $data['table_name']){
            $prefix=config("database.connections.mysql.prefix");
            $oldTableName=$prefix.$oldTableName;

            $tableName=$prefix.$data['table_name'];
            $sql=" alter table {$oldTableName} rename {$tableName} ";
            Db::execute($sql);
        }
        if($save !== false){
            return returnjson(1,'修改模型成功');
        }else{

            return returnjson(0,'修改模型失败');
        }
    }



}