<?php
/**
 * Created by PhpStorm.
 * User: pc
 * Date: 2021/4/8
 * Time: 12:19
 */

namespace app\admin\model;

use think\facade\Db;
use think\Model;
class ModelFields extends Model
{
    public function getmodeladd($data){
        $tableName=Db::name('model')->field('table_name')->find($data['model_id']);

        $tableName=config("database.connections.mysql.prefix").$tableName['table_name'];
        //过滤中文"，"
        if($data['field_values']){
            $data['field_values']=str_replace('，', ',', $data['field_values']);
        }

        $add=self::save($data);
        if ($add){
            switch ($data['field_type']) {
                case 1:
                case 2:
                case 3:
                case 4:
                case 6:
                    $fileType='varchar(150) not null default ""';
                    break;
                case 5:
                    $fileType='varchar(600) not null default ""';
                    break;
                case 7:
                    $fileType='float not null default "0.0"';
                    break;
                case 8:
                    $fileType='int not null default "0"';
                    break;
                case 9:
                    $fileType='longtext';
                    break;
                default:
                    $fileType='varchar(150) not null default ""';
                    break;
            }
            $sql="alter table {$tableName} add {$data['field_ename']} {$fileType}";
            Db::execute($sql);

            return returnjson(1,'添加字段成功');
        }else{
            return returnjson(0,'添加字段失败');

        }
    }

    public function getedit($data){
        $data=input('post.');
        //获取前缀
        $prefix=config('database.connections.mysql.prefix');
        $modelName=$prefix.'model';
        //连表查询所需要的表明及字段名称
        $fieldInfo=Db::name('model_fields')->field('a.field_ename,b.table_name')->alias('a')->join("$modelName b",'a.model_id = b.id')->find($data['id']);
        //需要修改字段的表明
        $tableName=$prefix.$fieldInfo['table_name'];
        //需要修改的字段名称
        $oldFieldName=$fieldInfo['field_ename'];
        //过滤中文"，"
        if($data['field_values']){
            $data['field_values']=str_replace('，', ',', $data['field_values']);
        }

        $save=Db::name('model_fields')->update($data);
        switch ($data['field_type']) {
            case 1:
            case 2:
            case 3:
            case 4:
            case 6:
                $fileType='varchar(150) not null default ""';
                break;
            case 5:
                $fileType='varchar(600) not null default ""';
                break;
            case 7:
                $fileType='float not null default "0.0"';
                break;
            case 8:
                $fileType='int not null default "0"';
                break;
            case 9:
                $fileType='longtext';
                break;
            default:
                $fileType='varchar(150) not null default ""';
                break;
        }
        //$sql="alter table {$tableName} add {$data['field_ename']} {$fileType}";
        $sql="alter table {$tableName} change {$oldFieldName}  {$data['field_ename']}  {$fileType}";
        Db::execute($sql);

        if ($save){
            return returnjson(1,'修改字段成功');
        }else{
            return returnjson(0,'修改字段失败');
        }
    }

    public function ajaxdel($modelFieldsId){
        $prefix=config('database.connections.mysql.prefix');
        $modelName=$prefix.'model';
        //连表查询所需要的表明及字段名称
        $fieldInfo=Db::name('model_fields')->field('a.field_ename,b.table_name')->alias('a')->join("$modelName b",'a.model_id = b.id')->find($modelFieldsId);
        //需要删除字段的表明
        $tableName=$prefix.$fieldInfo['table_name'];
        //需要删除的字段名称
        $fieldName=$fieldInfo['field_ename'];

        $del=Db::name('model_fields')->delete($modelFieldsId);
        //sql
        $sql="alter table  {$tableName}  drop column {$fieldName}";
        Db::execute($sql);

        if ($del){
            return returnjson(1,'删除字段成功');
        }else{
            return returnjson(0,'删除字段失败');
        }

    }
}