<?php
/**
 * Created by PhpStorm.
 * User: pc
 * Date: 2020/12/6
 * Time: 15:01
 */

namespace app\admin\model;

use QL\QueryList;
use phpQuery;

use think\facade\Db;
set_time_limit(0);
header("Content-Type: text/html;charset=utf-8");

use think\Model;

class Note extends Model
{
    public $doCaiji;
    public $itemRules;
    public $id;
    public $img;

    public function doCaiji($dataList, $itemRules, $id)
    {
        $dataListarr = [];

        foreach ($dataList as $v) {
            if (strpos($v, '.html') !== false) {
                $dataListarr[] = $v;
            }
        }
       // $dataListarr = explode(',', 'https://www.ygdy8.net/html/gndy/dyzz/20110606/32626.html');
        //$dataListarr= explode(',','https://www.ygdy8.net/html/gndy/dyzz/20200106/59552.html');
        $this->dataList = $dataListarr;
        $this->itemRules = $itemRules;
        $this->id = $id;
        //多线程扩展

        $this->img = '/public/static/img/' . date('Y-m-d');
        $cm = QueryList::run('Multi', [
            //待采集链接集合
            'list' => $dataListarr,
            'curl' => [
                'opt' => array(
                    //这里根据自身需求设置curl参数
                    CURLOPT_SSL_VERIFYPEER => false,
                    CURLOPT_SSL_VERIFYHOST => false,
                    CURLOPT_FOLLOWLOCATION => true,
                    CURLOPT_AUTOREFERER => true,
                    //........
                ),
                //设置线程数
                'maxThread' => 10,
                //设置最大尝试数
                'maxTry' => 3
            ],
            'success' => function ($a) {
                //采集规则
                //防止重复采集
                $reData = Db::name('html')->where(array('url' => $a['info']['url']))->find();
                if (!$reData) {
                    $reg = $this->itemRules;
                    $html = iconv('utf-8', 'utf-8//IGNORE', file_get_contents($a['info']['url']));
                    $ql = QueryList::Query($html, $reg, '', 'utf-8', 'utf-8');

                    if (isset($ql->data[0]['title'])) {
                        $_dataItem[] = $ql->getData(function ($item) {
                            //图片本地化
                            $item['content'] = QueryList::run('DImage', [
                                'content' => $item['content'],
                                'image_path' => $this->img,
                                'www_root' => ROOT_PATH
                            ]);
                            return $item;
                        });


                        //数组重构
                        $dataItem = [];
                        foreach ($_dataItem as $k => $v) {
                            foreach ($v as $k1 => $v1) {
                                $video=[
                                    'video_title'=>'高清视频',
                                    'video_description'=>$v1['content'],
                                    'video_url'=>$v1['source']
                                ];
                                $v1['video']=$video;
                                $dataItem[] = $v1;
                            }
                        }

                        foreach ($dataItem as $k => $v) {
                            $data['nid'] = $this->id;
                            $data['title'] = $v['title'];
                            //获取封面图
                            $soContent = $v['content'];
                            $soImages = "/<[img|IMG].*?src=[\'|\"](.*?(?:[\.gif|\.jpg|\.png]))[\'|\"].*?[\/]?>/";
                            preg_match_all($soImages, $soContent, $thePics);
                            $allPics = count($thePics[1]);

                            if ($allPics >= 1) {
                                $v['litpic'] = $thePics[1][0];
                            } else {
                                $v['litpic'] = '';
                            }

                            $data['url'] = $a['info']['url'];
                            $data['addtime'] = time();

                            $data['result'] = json_encode($v);

                            Db::name('html')->insert($data);
                        }
                    }
                }
            }
        ]);
        return true;
    }


//电视剧
    public function doCaijids($dataList, $itemRules, $id)
    {

        unset($itemRules['list_url_ces']);
        unset($itemRules['content_url']);

        $title=$itemRules['title'];
        $keywords=$itemRules['keywords'];
        $description=$itemRules['description'];
        $writer=$itemRules['writer'];
        $click=$itemRules['click'];
        $time=$itemRules['time'];
        $source=$itemRules['source'];
        $content=$itemRules['content'];

        $rules['title']=[$title[0],$title[1],$title[2]];
        $rules['keywords']=[$keywords[0],$keywords[1],$keywords[2]];
        $rules['description']=[$description[0],$description[1],$description[2]];
        $rules['click']=[$click[0],$click[1],$click[2]];
        $rules['writer']=[$writer[0],$writer[1],$writer[2]];
        $rules['source']=[$source[0],$source[1],$source[2]];
        $rules['content']=[$content[0],$content[1],$content[2]];
        $rules['time']=[$time[0],$time[1],$time[2]];

        $dataListarr = [];


        foreach ($dataList as $v) {
            foreach ($v as $v1){
                $dataListarr[] = $v1;
            }

        }

        $_dataItem=[];
        foreach ($dataListarr as $k => $v) {

            unset($itemRules['uid']);

           $_dataItem = QueryList::get($v['url'])->rules($rules)->query()->getData();
            $_dataItem=$_dataItem->toArray();
            $_dataItem['litpic']=$v['litpic'];

            $_dataItem['time']=strtotime(mb_ereg_replace('(　| )+$', '', $_dataItem['time']));
            $reData = Db::name('html')->where('nid',$id)->where(array('title' =>$_dataItem['title']))->find();
            if (!$reData && $_dataItem['title'] !==''){
                $datajson= json_encode($_dataItem);
                Db::name('html')->insert(['title'=>$_dataItem['title'],'url'=>$v['url'],'nid'=>$id,'addtime'=>time(),'result'=>$datajson]);
            }

        }

        return true;


    }

    //获取采集配置
    public function ConfCaiji($id){
        $notes=Db::name('note')->find($id);
        //采集参数
        //输出编码
        $outputEncoding=$notes['output_encoding'];
        //输入编码
        $inputEncoding=$notes['input_encoding'];
        //列表采集配置
        $listRules=$notes['list_rules'];
        //json转换为数组
        $listRules=json_decode($listRules,true);
        //内容页采集规则
        $itemRules=$notes['item_rules'];
        //json转换数组
        $itemRules=json_decode($itemRules,true);
        //采集列表网址
        $listUrl=$listRules['list_url'];
        //采集开始页码
        $startPage=$listRules['start_page'];
        //采集结束页码
        $endPage=$listRules['end_page'];
        //页码步长
        $step=$listRules['step'];
        //采集范围
        $range=$listRules['range'];
        //采集规则
        $listCaijiRules=$listRules['list_rules'];
        // dump($listCaijiRules); die;
        //动态读取列表采集规则
        $baseUrl = $notes['baseurl'];

        $listCaijiRules=array(
            'url'=>array($listCaijiRules['url'],'href','',function($content) use ($baseUrl){
                return $baseUrl.$content;
            }),
            'litpic'=>array($listCaijiRules['litpic'],'src'),
        );

       // $_listUrl,$listCaijiRules,$range,$outputEncoding,$inputEncoding startPage endPage step listUrl
        $conf=array(
            'listCaijiRules'=>$listCaijiRules,
            'range'=>$range,
            'outputEncoding'=>$outputEncoding,
            'inputEncoding'=>$inputEncoding,
            'startPage'=>$startPage,
            'endPage'=>$endPage,
            'step'=>$step,
            'listUrl'=>$listUrl,
            'itemRules'=>$itemRules,
            'notes'=>$notes,
        );
       return $conf;

    }

    public function getceslist($notes){

        //采集参数
        //输出编码
        $outputEncoding=$notes['output_encoding'];
        //输入编码
        $inputEncoding=$notes['input_encoding'];
        //列表采集配置
        $listRules=$notes['list_rules'];



        //采集列表网址
        $listUrl=$listRules['list_url'];
        //采集开始页码
        $startPage=$listRules['start_page'];
        //采集结束页码
        $endPage=$listRules['end_page'];
        //页码步长
        $step=$listRules['step'];
        //采集范围
        $range=$listRules['range'];
        //采集规则

        $listCaijiRules=$listRules['list_rules'];

        //动态读取列表采集规则
        $baseUrl = $notes['baseurl'];

        $listCaijiRules=array(
            'url'=>array($listCaijiRules['url'],'href','',function($content) use ($baseUrl){
                return $baseUrl.$content;
            }),
            'litpic'=>array($listCaijiRules['litpic'],'src'),
        );

        // $_listUrl,$listCaijiRules,$range,$outputEncoding,$inputEncoding startPage endPage step listUrl
        $conf=array(
            'listCaijiRules'=>$listCaijiRules,
            'range'=>$range,
            'outputEncoding'=>$outputEncoding,
            'inputEncoding'=>$inputEncoding,
            'startPage'=>$startPage,
            'endPage'=>$endPage,
            'step'=>$step,
            'listUrl'=>$listUrl,
            'notes'=>$notes,
        );
        return $conf;
    }


    //文章采集测试
    public function ces_content_url($url, $itemRules)
    {
        $_dataItem = QueryList::get($url)->rules($itemRules)->query()->getData();

        return $_dataItem;


    }


    //更新
    public function doCaijidsgx($dataList, $itemRules, $id)
    {
        $dataListarr = [];

        foreach ($dataList as $v) {
            if (strpos($v, '.html') !== false) {
                $dataListarr[] = $v;
            }
        }
        $this->dataList = $dataListarr;
        $this->itemRules = $itemRules;
        $this->id = $id;
        //多线程扩展
        $reg = $this->itemRules;
        $_dataItem=[];
        foreach ($dataListarr as $k => $v) {
            $_dataItem[] = QueryList::Query($v,$reg,'','utf-8', 'utf-8')->data;
        }

        $_dataItemres=[];
        $i=1;
        $data['title']=$_dataItem[0][0]['title'];
        $data['content']=$_dataItem[0][0]['content'];
        $source=$_dataItem[0][0]['source'];
        $reData = Db::name('html')->where(array('title' =>$data['title']))->find();
        if ($reData){
             Db::name('html')->where(array('title' =>$data['title']))->delete();//删除已有数据

             //查询内容
//          $archives=  Db::name('archives')->where(array('title' =>$data['title']))->find();
//          $model=Db::name('model')->where(array('id' =>$archives['model_id']))->find();
//          $article=$model['table_name'];//附表名称
//          if ($archives){
//              $this->gxcaiji($_dataItem,$archives['id']);
////              Db::name('archives')->where('id','=',$archives['id'])->delete();
////              Db::name($article)->where('aid','=',$archives['id'])->delete();
////              Db::name('pics')->where('aid','=',$archives['id'])->delete();
//          }
        }
        foreach ($_dataItem as $k=>$v){
            foreach($v as $v1){
                $_dataItemres[]=[
                    'video_title'=>$i++,
                    'video_description'=>$v1['content'],
                    'video_url'=>$v1['source']
                ];
            }
        }
        $data['result'] = $_dataItemres;
        $datajson= json_encode($data);
        Db::name('html')->insert(['title'=>$data['title'],'url'=>$source,'nid'=>$id,'addtime'=>time(),'result'=>$datajson]);
        return true;

    }


    //循环采集数据
    public function caijilist($_listUrl,$listCaijiRules,$range,$outputEncoding,$inputEncoding){
        //循环采集数据

        $_data=[];
        $removeHead=true;
        foreach ($_listUrl as $k => $url) {

            if (file_get_contents($url,true)){
               // $url = 'https://it.ithome.com/internet';
                $rules = [
                    //'title' => $listCaijiRules,// 采集文章标题
                     'url' => [$listCaijiRules['url'][0],'href'],// 采集链接
                  //  'img' => ['img','src'],// 采集缩略图
////                    'desc' => ['.note','text']// 采集文档简介
                  ];// 元数据采集规则

                    $rangea = $range;// 切片选择器
                $_data[]= QueryList::get($url)->rules($listCaijiRules)->range($rangea)->query()->getData();

            }else{
                continue;
            }
        }


        //数组重构,列表采集数据结果集
//        $dataList=[];
//        $preg = "/^http(s)?:\\/\\/.+/";
//        foreach ($_data as $k => $v) {
//            foreach ($v as $k1 => $v1) {
//                if(preg_match($preg,$v1['url']))
//                {
//                    $dataList[]=$v1['url'];
//                }else
//                {
//                    $dataList[]='http://www.52dir.cn'.$v1['url'];
//                }
//            }
//        }

        return $_data;
    }

}

