<?php
/**
 * Created by PhpStorm.
 * User: pc
 * Date: 2021/4/12
 * Time: 13:18
 */

namespace app\admin\model;
use think\Model;
use think\facade\Db;
use think\facade\Cookie;
ini_set("max_execution_time", "600");
class Sitemap extends Model
{

    public static function GetAdd($data){

        if ($data['url']==''){
            return json(['code'=>0,"msg"=>'首页地址不能为空']);
        }
        if ($data['cates']!=='' || $data['page']!=='' || $data['art']!=='' || $data['url']!==''){

            $preg = "/^http(s)?:\\/\\/.+/";

            if(preg_match($preg,$data['url'])==0){
                return json(['code'=>0,"msg"=>'首页地址格式不得，正确格式‘http(s)’开头']);
            }

            if(strpos($data['cates'],'/') !== 0){
                return json(['code'=>0,"msg"=>'列表规则填写错误，正确格式‘/’开头']);
            }
            if(strpos($data['page'],'/') !== 0){
                return json(['code'=>0,"msg"=>'单页规则填写错误，正确格式‘/’开头']);
            }
            if(strpos($data['art'],'/') !== 0){
                return json(['code'=>0,"msg"=>'内容页规则填写错误，正确格式‘/’开头']);
            }
        }
        $paycate=Db::name('cate')->where('status','=','1')->order('id desc')->select()->toArray();
        $product=Db::name('product')->where('status','=','1')->order('id desc')->select()->toArray();

        $cate=Db::name('arc_cate')->where('status','=','1')->where('cate_attr','<','3')->order('id desc')->select()->toArray();
        $archives=Db::name('archives')->where('status','=','1')->where('attr','in','0,1,3,4')->order('id desc')->select()->toArray();
        $keywords=Db::name('archives')->where('status','=','1')->where('attr','in','0,1,3,4')->column('keywords');

        $keywords=array_filter($keywords);
        $keywords= array_unique($keywords);
        $keywords=implode(',',$keywords);
        $keywords=array_unique(explode(',',$keywords));
        $keywords=explode(',',implode(',',$keywords)) ;


        $urlres = [];
        $urlres[]=[
            'name'=>'首页',
            'url'=>$data['url']
        ];
        if ($data['cates']==''){
            $cates='/cates-';
        }else{
            $cates=$data['cates'];
        }
        if ($data['page']==''){
            $page='/page-';
        }else{
            $page=$data['page'];
        }
        //商品
        if ($paycate){
            foreach ($paycate as $v){
                $urlcate['name'] = $v['cate_name'];
                $urlcate['url'] = $data['url'] . '/product-' . $v['id'].'.html';

                $urlres[] = $urlcate;
            }
        }

        foreach ($cate as $v){
            $urlcate['name'] = $v['cate_name'];
            if ($v['cate_attr']=='1'){
                $urlcate['url'] = $data['url']  .$cates. $v['id'] . '.html';
            }
            if ($v['cate_attr']=='2'){
                $urlcate['url'] = $data['url']  .$page. $v['id'] . '.html';
            }
            $urlres[] = $urlcate;
        }

        if ($data['art']==''){
            $art='/art-';
        }else{
            $art=$data['art'];
        }


        $archivesres = [];
        foreach ($archives as $v) {
            $urlcate['name'] = $v['title'];
            $urlcate['url'] =  $data['url'] . $art . $v['id'] . '.html';
            $archivesres[] = $urlcate;
        }

        foreach ($keywords as $v) {
            if ($v!==''){
                $urlcate['name'] = $v;
                $urlcate['url'] =  $data['url'] . '/search?keywords='.$v;
                $archivesres[] = $urlcate;
            }
        }

        foreach ($product as $v) {
            $urlcate['name'] = $v['item_name'];
            $urlcate['url'] =  $data['url'] . '/pay-' . $v['id'] . '.html';
            $archivesres[] = $urlcate;
        }
        //商品详情

        $archives = array_merge_recursive($urlres, $archivesres);

        if ($data['sitemap']!==''){
            $sitemap=$data['sitemap'];
        }else{
            $sitemap="sitemap";
        }
        $confadmin=Db::connect('demo')->table('tp_admin')->find(Cookie::get('uid'));
        $confconf=Db::connect('demo')->table('tp_conf')->find($confadmin['uid']);
       // $path=$confconf['public'].'/public/';
        $indexurl= $confconf['public'].'/public/index.php';

        if (file_exists($indexurl)){
            $path=$confconf['public'].'/public/';
        }else{
            $path=$confconf['public'].'/';
        }

        if (!empty($data['txt'])){
            $txt = Sitemap::txt($archives,$sitemap,$path);
            if ($txt !== true) {
                return json(['code'=>0,"msg"=>'生成txt出现错误']);
            }
        }

        if (!empty($data['xml'])){
            $xml = Sitemap::xml($archives,$sitemap,$data['frequency'],$path);
            if ($xml !== true) {
                return json(['code'=>0,"msg"=>'生成xml出现错误']);
            }
        }
        if (!empty($data['html'])){
            $sitename = "";//网站名称
            $html = Sitemap::html($archives,$sitemap,$sitename,$path);
            if ($html !== true) {
                return json(['code'=>0,"msg"=>'生成html出现错误']);
            }
        }

        return json(['code'=>1,"msg"=>'生成完成']);
    }
    //txt
    public static function txt($archives,$sitemap,$path)
    {

        $myfile = fopen($path.$sitemap.".txt", "w") or die("Unable to open file!");
        foreach ($archives as $v) {
            //  fwrite($myfile, $v['url'] . "\n");
            fwrite($myfile, mb_convert_encoding( $v['url'], 'UTF-8', mb_detect_encoding($v['url']) ) . "\n");
        }
        fclose($myfile);
        return true;
    }

//xml
    public static function xml($archives,$sitemap,$frequency,$path)
    {

        $myfile = fopen($path.$sitemap.".xml", "w") or die("Unable to open file!");

        $top = "<?xml version='1.0' encoding='UTF-8'?><urlset>";
        fwrite($myfile, $top . "\n");
        foreach ($archives as $v) {
            if ($v['url']=='https://www.hbsjsd.cn'){
                $priority='1.0';
            }else{

                if (strpos($v['url'], "/art-")){
                    $priority='0.8';
                }elseif (strpos($v['url'], "/search")){
                    $priority='0.7';
                }else{
                    $priority='0.9';
                }

            }
            $ur = $v['url'];
            $time = date('Y-m-d', time());
            $s = "\t\t<url>\n";
            $s .= "\t\t\t<loc>$ur</loc>\r\n";
            $s .= "\t\t\t<priority>$priority</priority>\r\n";
            $s .= "\t\t\t<lastmod>$time</lastmod>\r\n";
            $s .= "\t\t\t<changefreq>$frequency</changefreq>\r\n";
            $s .= "\t\t</url>\n";
            fwrite($myfile, $s . "\n");
        }
        $bottom = "</urlset>";
        fwrite($myfile, $bottom . "\n");
        fclose($myfile);
        return true;
    }

    public static function html($archives,$sitemap,$sitename,$path)
    {

        $myfile = fopen($path.$sitemap.".html", "w") or die("Unable to open file!");

        $top = "<!DOCTYPE html>
<html>\n
<head>\n
\t\t<meta charset='utf-8' />\n
\t\t<title>网站地图</title>\n
<style>\n
	html, body, div,
	h1, h2, h3, h4, h5, h6,
	hr, p, blockquote,
	dl, dt, dd, ul, ol, li,
	pre, form, fieldset, object, code,
	legend, button, input, textarea, label,
	th, td, a, img {
		margin: 0;
		padding: 0;
		border: 0;
		outline: 0;
	}
	a{text-decoration:none;text-decoration-line:none;color: #666; }
	a:hover{text-decoration:none;outline:0;}
	a:hover, a:focus {  text-decoration: none;  }
	ol{max-width: 1200px;margin: 0px auto;list-style-type:none;}
	li{line-height: 35px;height: 35px;width: 48%;float: left}
	li a{   height: 35px;
		line-height: 35px;
		display: inline-block;
		white-space: nowrap;
		width: 100%;
		overflow: hidden;
		text-overflow:ellipsis;
	}
	li:nth-child(even){
	float: right;
	}
</style>\n
</head>\n
<body>\n
<ol>\n
<h3 style='text-align: center;padding: 20px 0;'>网站地图</h3>";
        fwrite($myfile, $top . "\n");
        foreach ($archives as $v) {
//
//            $lines_array = file($v['url']);
//
//            $lines_string = implode('', $lines_array);
//
//            preg_match("@<title[^>]*>(.*?)</title>@si",$lines_string, $regs);
//
//
//
//            $ur = $v['url'];
//            $name =$regs[1];
            // $s = "\t\t<li><a href='$ur'>$name</a></li>";
            $ur = $v['url'];
            $name =$v['name'];

            $s = "\t\t<li><a href='$ur'>$name</a></li>";
        
            fwrite($myfile, $s . "\n");
        }
        $bottom = "</ol>\n</body>\n</html>";
        fwrite($myfile, $bottom . "\n");
        fclose($myfile);
        return true;
    }



}