<?php
namespace app\admin\validate;
use think\Validate;
use think\exception\ValidateException;

class Admin extends Validate
{
	protected $rule=[
		'uname'=>'require|unique:admin|min:5',
		'groupid'=>'require',
		'password'=>'require|min:6',
	];

	protected $message=[
		'uname.require'=>'管理员名称不得为空！',
		'uname.unique'=>'管理员名称不得重复！',
        'uname.min'=>'用户名不能少于5位！',
		'groupid.require'=>'所属用户组不得为空',
		'password.require'=>'管理员密码不能为空！',
		'password.min'=>'管理员密码不能少于6位！',
	];

	protected $scene=[
		'add'=>['uname','password','groupid'],
		'edit'=>['uname','groupid'],
        'login'=>['uname'=>'require,min:5','password'],
	];
}