<?php
declare (strict_types = 1);

namespace app\api\controller\v1;
use app\Request;
use think\facade\Db;
use app\api\model\Archives as ArchivesModel;
class Archives extends CommonArc
{

    //获取导航
    public function cate(Request $request)
    {
        $data = $request->param();

       $_data= (new ArchivesModel())->getCate($data['bottom']);
        return return_msg('ok',$_data);
    }
    //当前栏目子栏目
    public function porcate(Request $request)
    {
        $data = $request->param();
        $topCates = Db::name('arc_cate')->find($data['cid']);//顶级栏目信息
        $topcid = (new ArchivesModel())->getTopId($data['cid']);//顶级栏目id
        $sonCateRes = Db::name('arc_cate')->where(array('pid' => $topcid))->where(array('status' => 1))->order('sort desc,id desc')->select();//获取子栏目
        $_data=[
            'topCates'=>$topCates,
            'sonCateRes'=>$sonCateRes
        ];
        return return_msg('ok',$_data);
    }
    //当前位置
    public function por(Request $request)
    {
        $data = $request->param();
        $pos=(new ArchivesModel())->position($data['cid']);
        return return_msg('ok',$pos);
    }
    //获取文章列表
    public function list(Request $request)
    {
        $data = $request->param();

        $topCates = Db::name('arc_cate')->find($data['cid']);//顶级栏目信息

        if($topCates['pid']==0){
            $sonCateRes = Db::name('arc_cate')->where(array('pid' => $topCates['id']))->where(array('status' => 1))->column('id');//获取子栏目
            $sonCateRes[]=$data['cid'];
            $cid=$sonCateRes;


        }else{
           $cid[] = $data['cid'];
        }
  
        //获取列表数据
        $artRes = Db::name('archives')->field('a.id,a.title,a.url,a.status,a.attr,a.attr_time,a.keywords,a.description,a.click,a.time,c.cate_name,d.cate_id,p.pic')->alias('a')
            ->join('archives_id d', 'a.id=d.aid')
            ->where("d.cate_id",'in',$cid)
            ->join('pics p', 'a.id=p.aid', 'LEFT')
            ->join('arc_cate c', 'd.cate_id=c.id')
            ->order('a.attr_time desc,a.time desc,a.id desc')
            ->group('a.id')->select()->toArray();

        $currpage = page_array($artRes, $data['limit'], $data['page']);
        $dataarr = [
            "status" => 200,
            "hint" => "数据",
            "total" => count($artRes),
            "page" => $currpage['page'],
            "rows" => $currpage['data']
        ];
        if (count($currpage['data']) > 0) {
            $dataarr['msg'] = 'ok';
            $dataarr['status'] = 200;
        } else {
            $dataarr['msg'] = "无数据";
            $dataarr['status'] = 200;
        }

        return return_msg('ok',$dataarr);

    }

    //获取文章详情
    public function archives(Request $request)
    {
        $data = $request->param();
        $arts=Db::name('archives_id')->where('aid','=',$data['cid'])->find();

        $cid=$arts['cate_id'];
        $cates=Db::name('arc_cate')->find($cid);

        $arts=Db::name('archives')->alias('a')->join('pics p','a.id=p.aid','LEFT')->group('a.id')->field('a.*,p.pic')->find($data['cid']);
        if ($arts['markdown']=='markdown'){
            $content_html=json_decode($arts['content'],true);

            $arts['content']=$content_html['html'];
        }

        $arts['imgres']= json_decode($arts['imgres'],true);
   

        $arts['cate_name']=$cates['cate_name'];
        return return_msg('ok',$arts);

    }
    //获取网站配置
    public function conf(Request $request)
    {
        $_data= (new ArchivesModel())->getConf();
        return return_msg('ok',$_data);
    }
    //用户留言
    public function sms(Request $request){
        $_data = $request->param();

        $rule = '^1(3|4|5|7|8)[0-9]\d{8}$^';
        $result = preg_match($rule, $_data['phonenumber']);
        if (!$result) {
            return json(['code'=>0,"msg"=>'格式不对']);
        };
        if ($_data['title']=='' || $_data['content']==''){
            return json(['code'=>0,"msg"=>'留言内容不能为空！']);
        }

        $time=strtotime(date('Y-m-d 00:00:00'));
        $phoneres=Db::name('sms')->where('phonenumber',$_data['phonenumber'])->where('time','>=',$time)->select();
        if ($phoneres->count()>3){
            return json(['code'=>0,"msg"=>'今天已经提交过，无需重复提交，如有急事科技联系负责人.电话：13207250969']);
        }

        $data['operate_ip']= request()->ip();
        $data['time']= $_data['timestamp'];
        $data['title']= $_data['title'];
        $data['content']= $_data['content'];
        $data['uname']= $_data['uname'];
        $data['phonenumber']= $_data['phonenumber'];

      $add=  Db::name('sms')->insert($data);

        $html='<table class="table mb-0" width="100%" style=" border-collapse:collapse;"><tbody><tr class="firstRow" style="height: 40px;line-height: 40px"><td class="text-right bg-light" style="border-width: 1px; border-style: solid; border-color: rgb(221, 221, 221);" width="120">留言者：</td><td class="text-left" style="border-width: 1px; border-style: solid; border-color: rgb(221, 221, 221);" >'. $data['uname'].'</td> </tr><tr style="height: 40px;line-height: 40px"><td class="text-right bg-light" style="border-width: 1px; border-style: solid; border-color: rgb(221, 221, 221);" width="120">联系方式：</td><td class="text-left" style="border-width: 1px; border-style: solid; border-color: rgb(221, 221, 221);" >'.$_data['phonenumber'].'</td></tr><tr style="height: 40px;line-height: 40px"><td class="text-right bg-light" style="border-width: 1px; border-style: solid; border-color: rgb(221, 221, 221);" width="120">标题：</td><td class="text-left" style="border-width: 1px; border-style: solid; border-color: rgb(221, 221, 221);"> '. $_data['title'].'</td></tr><tr style="height: 40px;line-height: 40px"><td class="text-right bg-light" style="border-width: 1px; border-style: solid; border-color: rgb(221, 221, 221);" width="120">详情：</td><td class="text-left" style="border-width: 1px; border-style: solid; border-color: rgb(221, 221, 221);"> '. $_data['content'].'</td></tr></tbody></table>';
        $url='https://www.hbsjsd.cn/api/word/sendmail';
        $data['toemial']='276255486@qq.com';
        $data['account']=$_data['title'];
        $data['url']='';
        $data['title']='用户留言';
        $data['html']=$html;
        $data= $this->http_request($url,$data);

        if ($add){
            return return_msg('ok','发布成功');
        }
        return return_msg('0','发布失败');
    }

}
