<?php
declare (strict_types = 1);

namespace app\api\controller\v2;
use app\BaseController;
use app\Request;
use think\facade\Db;

class Index extends BaseController
{
    public function index()
    {
        return '您好！这是一个[api]示例应用-V2';
    }
    public function test(Request $request)
    {
        $url= input('url');
        $where='url LIKE "%'.$url.'%"';
       $res= Db::name('webser')->where($where)->find();
       if (!$res){
          $month =strtotime(date('Y-m-d H:i:s',strtotime('+6 month')));
           Db::name('webser')->insert(['url'=>$url,'time'=>time(),'end_time'=>$month]);
       }
       $service= Db::name('service')->where($where)->find();
       if (!$service){
           if ($res['end_time']<time()){
               return return_msg('0','未授权用户请尽快授权后在使用');
           }else{
               return return_msg('ok','未授权试用中');
           }
       }else{
           return return_msg('ok','已授权可以正式使用');
       }

       // return '测试接口-V2';
    }

    //获取文章列表
    public function v2list(Request $request)
    {
        $data = $request->param();

        $topCates = Db::name('arc_cate')->find($data['cid']);//顶级栏目信息

        if($topCates['pid']==0){
            $sonCateRes = Db::name('arc_cate')->where(array('pid' => $topCates['id']))->where(array('status' => 1))->column('id');//获取子栏目
            $cid[]=$data['cid'];
            $cid[]=$sonCateRes;
        }else{
            $cid[] = $data['cid'];
        }

        //获取列表数据
        $artRes = Db::name('archives')->field('a.id,a.title,a.url,a.status,a.attr,a.attr_time,a.keywords,a.description,a.click,a.time,c.cate_name,d.cate_id,p.pic')->alias('a')
            ->join('archives_id d', 'a.id=d.aid')
            ->where("d.cate_id",'in',$cid)
            ->join('pics p', 'a.id=p.aid', 'LEFT')
            ->join('arc_cate c', 'd.cate_id=c.id')
            ->order('a.attr_time desc,a.time desc，a.id desc')
            ->group('a.id')->select()->toArray();

        $currpage = page_array($artRes, $data['limit'], $data['page']);

        $dataarr = [
            "status" => 200,
            "hint" => "数据",
            "total" => count($artRes),
            "page" => $currpage['page'],
            "rows" => $currpage['data']
        ];
        if (count($currpage['data']) > 0) {
            $dataarr['msg'] = 'ok';
            $dataarr['status'] = 200;
        } else {
            $dataarr['msg'] = "无数据";
            $dataarr['status'] = 200;
        }

        return return_msg('ok',$dataarr);

    }
    public function v2gengxin(Request $request){
        $data = $request->param();
        //day
        $dateday = date('Y-m-d',strtotime('-3 day'));

        $update= Db::name('demo')->order('id desc')->limit(15)->select();
        $notice= Db::name('notice')->where('time', '>', $dateday)->order('id desc')->find();

        $arr=[];
        foreach ($update as $v){
            $data['id']=$v['id'];
            $data['title']=$v['edition'];
            $data['time']=strtotime($v['time']);
            $data['description']=$v['description'];
            $data['source']=$v['source'];
            $data['model']=$v['model'];
            $arr[]=$data;
        }
        $array['data']=$arr;
        $array['notice']=$notice;
        return return_msg('ok',$array);
    }


}
