<?php
/**
 * Created by PhpStorm.
 * User: pc
 * Date: 2020/4/13
 * Time: 12:08
 */

namespace app\api\libs;
use app\api\exception\HttpExceptions;
use think\Exception;
use think\facade\Db;
trait Checkdata
{

//验证时间戳
    protected function checkTime(){

       // $this->request->except(['timestamp','ver'])
        if (!$this->request->has('timestamp') || intval($this->request->get('timestamp'))<=1|| strlen($this->request->get('timestamp'))!==10){
            //  return $this->return_msg("时间戳错误",[],19997,400);
            throw new HttpExceptions(400, "时间戳错误",19997);
        }
        if (abs(time()-intval($this->request->get('timestamp')))>60){
            throw new HttpExceptions(400, "请求超时",19997);
        }
    }
//    //验证签名
    protected function checkSign(){

        if ($this->request->header('sign')==''){
            //  return $this->return_msg("时间戳错误",[],19997,400);
            throw new HttpExceptions(400, "签名参数错误",19996);
        }
      //  dump($this->request->except(['ver']));die;
        //验证签名
        $sign=$this->createSign();

        if ($this->request->header('sign') !==$sign){
            //  return $this->return_msg("时间戳错误",[],19997,400);
            throw new HttpExceptions(400, "签名错误",19995);
        }

    }
    //生成签名
    protected function createSign(){
        $sign_data=$this->request->except(['ver','sign','page','limit','order','pid','num','amount','uname','arr','city','peisong']);

        ksort($sign_data);//排序
        $sign_data_str=http_build_query($sign_data);
    //    halt( md5($sign_data_str));
        return md5($sign_data_str);


    }

    //封装同统一返回格式
    protected function return_msg($msg="ok",$data=[],$errorcode=0,$httpcode=200){
        $msg_data=[
            "message"=>$msg,
            "data"=>$data,
            "errorcode"=>$errorcode
        ];
        return json($msg_data,$httpcode);
    }
}