<?php



// 应用公共文件
function returnjson($code=1,$msg=""){
    return json(['code'=>$code,'msg'=>$msg]);
};
//判断域名是否html
function get_ueditor($name,$value='',$height=400){
    $str=<<<HTML
	<textarea name='$name' id='$name'>$value</textarea>
	<script type="text/javascript">
		UE.getEditor('$name',{toolbars:[
        [
                'fullscreen', 'source', '|', 'undo', 'redo', '|',
                'bold', 'italic', 'underline', 'fontborder', 'strikethrough', 'pasteplain', '|', 'forecolor', 'backcolor', 'insertorderedlist', 'insertunorderedlist', 'selectall', 'cleardoc', '|', 'removeformat', 'formatmatch', 'autotypeset',
                'rowspacingtop', 'rowspacingbottom', 'lineheight', '|',
                'customstyle', 'paragraph', 'fontfamily', 'fontsize', '|',
                'directionalityltr', 'directionalityrtl', 'indent', '|',
                'justifyleft', 'justifycenter', 'justifyright', 'justifyjustify', '|', 'touppercase', 'tolowercase', '|',
                'link', 'unlink', 'anchor', '|', 'imagenone', 'imageleft', 'imageright', 'imagecenter', '|',
                'simpleupload', 'insertimage', 'emotion', 'scrawl', 'insertvideo', 'music', 'attachment'
        ]

        ],initialFrameWidth:null,initialFrameHeight:$height});
	</script>
HTML;
    return $str;
}

function markdown($name){
    
        $str=<<<HTML
        <div id="test-editor">
            <textarea style="display:none;">$name</textarea>
        </div>
<script src="/static/admin/markdown/editormd.min.js"></script>
<script type="text/javascript">
    $(function() {
        var editor = editormd("test-editor", {
             width  : "100%",
            height : "500px",
            path   : "/static/admin/markdown/lib/"
            ,imageUpload : true,
            syncScrolling : "single"
            ,imageFormats : ["jpg", "jpeg", "gif", "png", "bmp", "webp"]
             ,imageUploadURL : "/Upload/uploadimg?bai=editormd"
             ,saveHTMLToTextarea : true
        });
    });
</script>
HTML;

    return $str;
}
function ueditor($name){

    $str=<<<HTML
    <textarea name="content" id="content" >$name</textarea>
<script src="/static/admin/ueditor/ueditor.config.js"></script>
<script src="/static/admin/ueditor/ueditor.all.min.js"></script>
<script src="/static/admin/ueditor/lang/zh-cn/zh-cn.js"></script>
<script type="text/javascript" src="/static/admin/js/ueditor.js"></script>
HTML;
    return $str;
}

function create_list($pid, $arr, &$tree = [])
{
    foreach ($arr as $key => $vo) {
        if ($vo['ppid'] == $pid) {
            unset($vo['ppid']);
            $vo['spread']=true;
            $c = create_list($vo['id'], $arr);

            if ($c) {

                $vo['children'] = $c;
            }
            $tree[] = $vo;
        }
    }
    return $tree;
}

function ruleRes($pid, $arr, &$tree = [])
{
    foreach ($arr as $key => $vo) {
        if ($vo['pid'] == $pid) {
            unset($vo['pid']);
            $vo['spread']=true;
            $c = ruleRes($vo['id'], $arr);

            if ($c) {

                $vo['children'] = $c;
            }
            $tree[] = $vo;
        }
    }
    return $tree;
}

/**
 *  post提交数据
 * @param  string $url 请求Url
 * @param  array $datas 提交的数据
 * @return url响应返回的html
 */
function sendPost($url, $datas) {
    $postdata = http_build_query($datas);
    $options = array(
        'http' => array(
            'method' => 'POST',
            'header' => 'Content-type:application/x-www-form-urlencoded',
            'content' => $postdata,
            'timeout' => 15 * 60 // 超时时间（单位:s）
        )
    );
    $context = stream_context_create($options);
    $result = file_get_contents($url, false, $context);
    return $result;
}


function errcode($code){
    switch ($code){
        case "930555":
            $icon="平台系统错误";
            break;
        case "930556":
            $icon="配送公司超时";
            break;
        case "930557":
            $icon="配送公司系统错误";
            break;
        case "930558":
            $icon="配送公司逻辑错误";
            break;
        case "930559":
            $icon="openid无效";
            break;
        case "930560":
            $icon="未绑定的商户号";
            break;
        case "930561":
            $icon="参数错误";
            break;
        case "930562":
            $icon="配送单已经存在";
            break;
        case "930563":
            $icon="配送单不存在";
            break;
        case "930564":
            $icon="调用无配额";
            break;
        case "930565":
            $icon="配送单已结束";
            break;
        case "9300535":
            $icon="shop字段商品缩略图 url、商品名称为空或者非法，或者商品数量为0";
            break;
        default :
            $icon='其他';
    }
    return $icon;
}
function order_status($data){
    switch ($data){
        case "101":
            $icon="等待分配骑手";
            break;
        case "102":
            $icon="分配骑手成功";
            break;
        case "103":
            $icon="商家取消订单， 订单结束";
            break;
        case "201":
            $icon="骑手到店开始取货";
            break;
        case "202":
            $icon="取货成功";
            break;
        case "203":
            $icon="取货失败，商家取消订单， 订单结束";
            break;
        case "204":
            $icon="取货失败，骑手因自身原因取消订单， 订单结束";
            break;
        case "205":
            $icon="取货失败，骑手因商家原因取消订单， 订单结束";
            break;
        case "301":
            $icon="配送中";
            break;
        case "302":
            $icon="配送成功， 订单结束";
            break;
        case "303":
            $icon="商家取消订单，配送物品开始返还商家";
            break;
        case "304":
            $icon="无法联系收货人，配送物品开始返还商家";
            break;
        case "305":
            $icon="收货人拒收，配送物品开始返还商家";
            break;
        case "401":
            $icon="货品返还商户成功， 订单结束";
            break;
        case "501":
            $icon="因运力系统原因取消， 订单结束";
            break;
        case "502":
            $icon="因不可抗拒因素（天气，道路管制等原因）取消，订单结束";
            break;
        default :
            $icon='其他';
    }
    return $icon;
}

function action_type($data){
    switch ($data){
        case "100001":
            $icon="揽件成功";
            break;
        case "100002":
            $icon="揽件失败";
            break;
        case "100003":
            $icon=" 分配业务员";
            break;
        case "200001":
            $icon="运输中";
            break;
        case "300002":
            $icon="开始派送";
            break;
        case "300003":
            $icon="签收成功";
            break;
        case "300004":
            $icon="签收失败";
            break;
        case "400001":
            $icon="订单取消";
            break;
        case "400002":
            $icon="订单滞留";
            break;
        default :
            $icon='运输中';
    }
    return $icon;
}

function gethttp($url){
    $preg = "/^http(s)?:\\/\\/.+/";
    if(preg_match($preg,$url)){
        return true;
    }else{
        return false;
    }
}
function ossimgurl($pic){

        $exc=strtoupper(substr($pic,strrpos($pic,".")));

        if ($exc==".MP4"){
            return $pic.'?x-oss-process=video/snapshot,t_7000,f_jpg,w_160,h_100,m_fast';
        }
        return $pic;
 }


function child($data,$iid='',$kay=''){
    foreach ($data as $k=>$v) {
        $child[$k]['id'] = $kay.$k;
        $child[$k]['title'] = $v;
        if ($iid!==''){
            if (in_array($k,$iid)){
                $child[$k]['checked']= true;
            }
        }

    }
    return $child;
}

/**

 * PHP将网页上的图片攫取到本地存储

 * @param $imgUrl  图片url地址

 * @param string $saveDir 本地存储路径 默认存储在当前路径

 * @param null $fileName 图片存储到本地的文件名

 * @return mix

 */

function crabImage($imgUrl, $saveDir, $fileName=null){

    if(empty($imgUrl)){
        return false;
    }

    //获取图片信息大小
    $imgSize = getImageSize($imgUrl);
    if(!in_array($imgSize['mime'],array('image/jpg', 'image/gif', 'image/png', 'image/jpeg'),true)){
        return false;
    }
    //获取后缀名
    $_mime = explode('/', $imgSize['mime']);
    $_ext = '.'.end($_mime);

    if(empty($fileName)){  //生成唯一的文件名
        $fileName = uniqid(time(),true).$_ext;
    }
    //开始攫取
    ob_start();
    readfile($imgUrl);
    $imgInfo = ob_get_contents();
    ob_end_clean();
    if(!file_exists($saveDir)){
        mkdir($saveDir,0777,true);
    }
    $fp = fopen($saveDir.$fileName, 'a');
    $imgLen = strlen($imgInfo);    //计算图片源码大小
    $_inx = 1024;   //每次写入1k
    $_time = ceil($imgLen/$_inx);
    for($i=0; $i<$_time; $i++){
        fwrite($fp,substr($imgInfo, $i*$_inx, $_inx));
    }
    fclose($fp);
    //返回结果
    return $fileName;
}