<?php
/**
 * Created by PhpStorm.
 * User: HP
 * Date: 2022/4/12
 * Time: 12:20
 */

namespace app\model;

use app\BaseController;
use think\facade\Db;
use app\Request;
use think\Model;

class Payrefund extends Model
{

    protected $name='pay';
    /**
     * @return App
     */
    public function refund($pay,$id,$amount='')
    {
        $resource=json_decode($pay['resource'],true);

        $merchantId = '1623813005'; // 商户号
        $merchantSerialNumber = '4CF1F0D673A681F7D61F51176D426129DC02D387'; // 商户API证书序列号
        $appid = 'wx870ceef75e00dd24'; //小程序appid
        $filepath ='static/admin/apiclient_key.pem';
        $file = file_get_contents($filepath);
        $mch_private_key = openssl_get_privatekey($file);

        $out_trade_no= date('YmdHis', time()) . rand(1000, 9999);
        if ($amount==''){
            $total=$resource['amount']['total'];
        }else{
            $total=$amount*100;
        }

        $data = [
            'transaction_id' => $resource['transaction_id'],
            'out_refund_no'  =>$out_trade_no,
            'reason'=>'商品已售完',
            'notify_url' => 'https://wxapi.hbsjsd.cn/v1/tueikuan',//退款回调地址
            'amount'         => [
                'refund'   => $total,
                'total'    => $resource['amount']['total'],
                'currency' => 'CNY',
            ]
        ];

        $timestamp = time();
        $nonce = date('YmdHis', time()) . rand(1000, 9999);
        $url = 'https://api.mch.weixin.qq.com/v3/refund/domestic/refunds';
        $url_parts = parse_url($url);
        $canonical_url = ($url_parts['path'] . (!empty($url_parts['query']) ? "?${url_parts['query']}" : ""));

        $data = json_encode($data);

        $message = 'POST' . "\n" .
            $canonical_url . "\n" .
            $timestamp . "\n" .
            $nonce . "\n" .
            $data . "\n";

        openssl_sign($message, $signature, $mch_private_key, "sha256WithRSAEncryption");
        $sign = base64_encode($signature);
        $schema = 'WECHATPAY2-SHA256-RSA2048';
        $token = sprintf('mchid="%s",nonce_str="%s",timestamp="%d",serial_no="%s",signature="%s"', $merchantId, $nonce, $timestamp, $merchantSerialNumber, $sign);

        $header = "Authorization: " . $schema . " " . $token;

        $res = $this->http_post($url, $header, $data);

        $arr = json_decode($res, true);

        if (isset($arr['message']) && $arr['message']=="订单已全额退款"){
           Db::name('pay')->where('id','=',$id)->update(['status'=>7]);
        }
        if (!isset($arr['status'])){
            return returnjson(0,$arr['message']);
        }

        $status= $this->statusswitch($arr['status']);

       $date= Db::name('pay')->where('id','=',$id)->update(['status'=>$status]);
        return returnjson(1,'退款成功');
    }

    public function statusswitch($status){
        switch ($status){
            case "SUCCESS":
                $icon="7";
                break;
            case "CLOSED":
                $icon="4";
                break;
            case "PROCESSING":
                $icon="5";
                break;
            case "ABNORMAL":
                $icon="6";
                break;
            default :
                $icon='6';
        }
        return $icon;
    }

    function http_post($url, $header, $data)
    {
        $headers[] = "Accept:application/json";
        $headers[] = "Content-Type:application/json";
        $headers[] = "User-Agent:application/json";
        $headers[] = $header;

        $curl = curl_init(); // 启动一个CURL会话
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_HEADER, 0);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false); // 跳过证书检查
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);  // 从证书中检查SSL加密算法是否存在
        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        $tmpInfo = curl_exec($curl);
        //关闭URL请求
        curl_close($curl);
        return $tmpInfo;
    }
}