<?php
// 应用公共文件
use think\facade\Db;

/**
 * 根据 Ip 获取地址位置
 */
function getIpInfo($internetIp = '')
{
    try
    {
      
        $bLocalIp = !filter_var($internetIp, FILTER_VALIDATE_IP, FILTER_FLAG_NO_PRIV_RANGE | FILTER_FLAG_NO_RES_RANGE);
        if($bLocalIp)
            $internetIp = 'myip';//局域网IP

        $requestAPi = "http://ip.taobao.com/service/getIpInfo.php?ip=" . $internetIp;
        $opts       = array(
            'http' => array(
                'method'  => 'GET',
                'timeout' => 1, // 单位秒
            )
        );
        $jsonArr = json_decode( file_get_contents($requestAPi, false, stream_context_create($opts)),
            JSON_HEX_TAG | JSON_HEX_QUOT | JSON_HEX_AMP | JSON_HEX_APOS );

        // 说明断网
        if (!isset($jsonArr) || !isset($jsonArr['code']))
        {
            return false;
        }

        // 0 表示成功
        if ($jsonArr['code'] !== 0)
        {
            return false;
        }

        $data = (array)$jsonArr['data'];
        return $data;
    }
    catch (\Exception $e)
    {

    }

    return false;
}

//生存导航地址
function makeurl($cate_attr=1,$cid){
    $url="";
//    switch ($cate_attr){
//        case 1:
//            $url=url('/Cate/index',['cid'=>$cid]);
//            break;
//        case 2:
//            $url=url('/Page/index',['cid'=>$cid]);
//            break;
//        default:
//            $url=url('/Index/index',['cid'=>$cid]);
//            break;
//    }
    switch ($cate_attr){
        case 1:
            $url="/cates-$cid.html";
            break;
        case 2:
            $url="/page-$cid.html";
            break;
        default:
            $url=url('/',['cid'=>$cid]);
            break;
    }
    $resulr=Db::name('arc_cate')->where('id',$cid)->find();
    if ($resulr['cate_attr']==3){
        $url=$resulr['link'];
    }
    return $url;
}
function urlart($aid,$url=0){

    if ($url==0){
        $url="/art-$aid.html";
        return $url;
    }else{

        return $url;
    }

}
function iphosts($url){
    $hosts=gethostbynamel($url);
    if (!$hosts){
        $hosts[0]='0.0.0.0';
    }
    return $hosts[0];
}
//跳转
function Arturl($attr,$cid,$url){
    switch ($attr){
        case 0:
            $url=url('/Article/index',['aid'=>$cid]);
            break;
        case 1:
            $url=$url;
            break;
        default:
            $url=url('/Article/index',['aid'=>$cid]);
            break;
    }

    return $url;
}
//判断单页图片是否为数组
function imgres($str,$sor){
    if (is_array($str)){
        return $str[$sor]['img'];
    }
    return $str;
}

//清除html标签
function delhtml($str){  //清除html标签
    //$str=strip_tags($str);
    $str=preg_replace("/(\s|\&nbsp\;|　|\xc2\xa0)/", " ", strip_tags($str));
    $st=-1; //开始
    $et=-1; //结束
    $stmp=array();
    $stmp[]=" ";
    $len=strlen($str);

    for($i=0;$i<$len;$i++){

        $ss=substr($str,$i,1);

        if(ord($ss)==60){
            $st=$i;
        }
        if(ord($ss)==62){ //ord(">")==62
            $et=$i;
            if($st!=-1){
                $stmp[]=substr($str,$st,$et-$st+1);
            }
        }
    }

    $str=str_replace($stmp,"",$str);
    return $str;

}
//字符串截取

function cut_str($sourcestr,$cutlength)

{

    $returnstr='';

    $i=0;

    $n=0;

    $str_length=strlen($sourcestr);//字符串的字节数

    while (($n<$cutlength) and ($i<=$str_length))

    {

        $temp_str=substr($sourcestr,$i,1);

        $ascnum=Ord($temp_str);//得到字符串中第$i位字符的ascii码

        if ($ascnum>=224)    //如果ASCII位高与224，

        {

            $returnstr=$returnstr.substr($sourcestr,$i,3); //根据UTF-8编码规范，将3个连续的字符计为单个字符

            $i=$i+3;            //实际Byte计为3

            $n++;            //字串长度计1

        }

        elseif ($ascnum>=192) //如果ASCII位高与192，

        {

            $returnstr=$returnstr.substr($sourcestr,$i,2); //根据UTF-8编码规范，将2个连续的字符计为单个字符

            $i=$i+2;            //实际Byte计为2

            $n++;            //字串长度计1

        }

        elseif ($ascnum>=65 && $ascnum<=90) //如果是大写字母，

        {

            $returnstr=$returnstr.substr($sourcestr,$i,1);

            $i=$i+1;            //实际的Byte数仍计1个

            $n++;            //但考虑整体美观，大写字母计成一个高位字符

        }

        else                //其他情况下，包括小写字母和半角标点符号，

        {

            $returnstr=$returnstr.substr($sourcestr,$i,1);

            $i=$i+1;            //实际的Byte数计1个

            $n=$n+0.5;        //小写字母和半角标点等与半个高位字符宽...

        }

    }

    if ($str_length>$i){

        $returnstr = $returnstr . "...";//超过长度时在尾处加上省略号

    }

    return $returnstr;

}
function img_url_to_base64($imgUrl)
{
    $imageInfo = getimagesize($imgUrl);
    return 'data:' . $imageInfo['mime'] . ';base64,' . chunk_split(base64_encode(file_get_contents($imgUrl)));
}

function lengthcount($length){
    return $length-3;
}

