<?php
/**
 * Created by PhpStorm.
 * User: pc
 * Date: 2021/4/27
 * Time: 15:21
 */

namespace app\template\controller;

use think\facade\Db;
use think\facade\View;
use app\template\model\Cate as CateModel;
use think\facade\Request;

class Article extends Common
{
    public function index($aid)
    {

        //判断带有/index.php跳转
        if(strpos(request()->url(),'/index.php') !== false){
            $index = str_replace("/index.php","",request()->url());
            return redirect($index);
        }

        $arts = Db::name('archives_id')->where('aid', $aid)->find();
        //判断文章不存在跳转首页
        if (!$arts) {
            return redirect('/');
            return;
        }
        $cid = $arts['cate_id'];
        $cates = Db::name('arc_cate')->find($cid);

        $arts = Db::name('archives')->alias('a')->join('pics p', 'a.id=p.aid', 'LEFT')->where('a.status', '=', 1)->group('a.id')->field('a.*,p.pic')->find($aid);

        //判断文章如果是外链跳转进入外链地址
        if ($arts['attr']==2){
            return redirect($arts['url']);
        }

        Db::name('click')->insert(['arc_id' => $aid, 'time' => time(), 'operate_ip' => Request::ip()]);
        Db::name('archives')->where('id', '=', $aid)->inc('click', $this->click)->update();
        $pics = Db::name('pics')->where('aid', '=', $aid)->select();
        if ($arts['markdown'] == 'markdown') {
            $content_html = json_decode($arts['content'], true);

            $arts['content'] = $content_html['doc'];
        }
        $arts['imgres'] = json_decode($arts['imgres'], true);
        $keywords = explode(',', $arts['keywords']);


        //查询二级栏目//最新信息
        $new = Db::name('archives')->alias('a')->join('pics p', 'a.id=p.aid', 'LEFT')->group('a.id')->where('a.status', '=', 1)->where('attr', 'in', '0,1,3,4')->field('a.*,p.pic')->limit(4)->order('a.time desc')->select();

        //随机文章
        $new1 = Db::name('archives')->alias('a')->join('pics p', 'a.id=p.aid', 'LEFT')->group('a.id')->where('a.status', '=', 1)->where('attr', 'in', '0,1,3,4')->orderRaw('rand()')->field('a.*,p.pic')->limit(4)->select();


        //获取顶级栏目id
        $topcid = (new CateModel())->getTopId($cid);
        $topCates = Db::name('arc_cate')->find($topcid);//顶级栏目信息
        $sonCateRes = Db::name('arc_cate')->where(array('pid' => $topcid))->where(array('status' => 1))->select();//更具主栏目ID获取子栏目id
        $pos = (new CateModel())->position($cid);

        $artTmp = $cates['article_tmp'];
        $tempSrc = $this->Conf . '/' . $artTmp;//路径

        //上一页//下一页
        $front = Db::name('archives')->where("id", '>', $aid)->where('status', '=', 1)->where('attr', 'in', '0,1,3,4')->order('id asc')->limit('1')->find();//上一页
        View::assign('front', $front);//上一页
        $after = Db::name('archives')->where("id", '<', $aid)->where('status', '=', 1)->where('attr', 'in', '0,1,3,4')->order('id desc')->limit('1')->find();//下一页
        View::assign('after', $after);//下一页

        View::assign([
            'pics' => $pics,
            'cid' => $cid,
            'cates' => $cates,
            "arts" => $arts, //获取列表数据
            "topCates" => $topCates,//顶级栏目信息
            "sonCateRes" => $sonCateRes,//更具主栏目ID获取子栏目id
            'pos' => $pos,//当前位置
            'topcid' => $topCates['id'],
            'keywords' => $keywords,
            'new' => $new,//最新信息
            'new1' => $new1,//最新信息
        ]);
        if (isset($this->iscache) && $this->iscache == '1') {
            $this->buildHtml($aid, app()->getRootPath() . "runtime/" . $this->lang . "/article/", $tempSrc);
        }
        return View::fetch($tempSrc);

    }

    //静态页面动态获取点击量
    public function click($cid)
    {
        $arts = Db::name('archives')->where('id', $cid)->field('click')->find();
        return returnjson('ok', $arts['click']);
    }

}