<?php
namespace app\template\controller;
use think\facade\Db;
use think\facade\View;
use think\facade\Request;
use app\template\model\Cate as CateModel;
class Cate extends Common
{

    public function index($cid){

        //判断带有/index.php跳转
        if(strpos(request()->url(),'/index.php') !== false){
            $index = str_replace("/index.php","",request()->url());
            return redirect($index);
        }
        //获取分页码
        $page = input('page');
        $cates=Db::name('arc_cate')->find($cid);
        //判断指定栏目的跳转
        if (!$cates){
            return redirect('/');
            return;
        }

        //判断指定栏目的跳转
        if (!$cates['jump_id']==0){
            $cid=$cates['jump_id'];
            $cates= Db::name('arc_cate')->find($cid);//查询跳转栏目信息
        }

        //h获取附加标
        Db::name('click')->insert(['cid'=>$cid,'time'=>time(),'operate_ip'=>Request::ip()]);
        $sid=(new CateModel())->childrenids($cid);
        $sid[]=intval($cid);

        $cateTmp=$cates['list_tmp'];
        $tempSrc=$this->Conf.$cateTmp;//路径
        //获取列表数据
        $artRes = Db::name('archives')->field('a.id,a.title,a.url,a.status,a.attr,a.attr_time,a.attr,a.keywords,a.description,a.content,a.source,a.click,a.time,a.imgres,c.cate_name,d.cate_id,p.pic,p.aid as picarr,a.model_id')->alias('a')
            ->withAttr('imgres', function ($value) {
                return json_decode($value,true);
            })
            ->withAttr('picarr', function ($value) {
                return (new CateModel())->picarr($value);
            })
            ->join('archives_id d', 'a.id=d.aid')
            ->where("d.cate_id",'in',$sid)
            ->join('pics p', 'a.id=p.aid', 'LEFT')
            ->join('arc_cate c', 'd.cate_id=c.id')
            ->order('a.attr_time desc,a.time desc,a.id desc')
            ->where('a.status','=',1)
            ->group('a.id')->paginate(15);

        //查询二级栏目
        $topcid = (new CateModel())->getTopId($cid);
        $topCates = Db::name('arc_cate')->find($topcid);//顶级栏目信息
        //更具主栏目ID获取子栏目id
        $sonCateRes = Db::name('arc_cate')->where(array('pid' => $topcid))->where(array('status' => 1))->select()->toArray();

        //当前位置
        $pos=(new CateModel())->position($cid);
        $pros=(new CateModel())->pros(6);//随机相关文章


       // 获取总记录数
        $count = $artRes->total();
        View::assign([
            'cates'=>$cates,
            "artRes"=>$artRes, //获取列表数据
            "topCates"=>$topCates,//顶级栏目信息
            "sonCateRes"=>$sonCateRes,//更具主栏目ID获取子栏目id
            'pos'=>$pos,//当前位置
            'cid'=>$cid,
            'pros'=>$pros,
            'topcid'=>$topcid,
            'count'=>$count
        ]);
        //生成静态页
        if(isset($this->iscache) && $this->iscache=='1'){
            if ($page){
                $ur = $cates['id'] . '_' . $page;
                $urrd = app()->getRootPath() . "runtime/".$this->lang."/html_id/" . $ur . '.html';
                $this->buildHtml($ur, app()->getRootPath() . "runtime/".$this->lang."/html_id/", $tempSrc);
                $tempSrc = app()->getRootPath() . "runtime/".$this->lang."/html_id/" . $ur . '.html';
            }else{
                $this->buildHtml($cid, app()->getRootPath() . "runtime/".$this->lang."/html/", $tempSrc);
                $tempSrc = app()->getRootPath() . "runtime/".$this->lang."/html/" . $cid . '.html';
            }
        }
        return  View::fetch($tempSrc);
    }




}