<?php
/**
 * Created by PhpStorm.
 * User: pc
 * Date: 2021/4/27
 * Time: 11:09
 */

namespace app\template\controller;
use app\BaseController;
use think\facade\View;
use think\facade\Db;
use app\model\Cate;
use think\facade\Cookie;
use think\facade\Config;
use think\facade\Lang;
use think\facade\Request;
use think\facade\Cache;
use app\template\model\Cate as Catemodel;
class Common extends BaseController
{

    public $Conf='';//获取模板路径
    public $click='1';
    public $conflist='';//获取配置文件
    public $iscache='0';
    public $lang='zh-cn';
  
    protected  function initialize()
    {

      
        parent::initialize(); // TODO: Change the autogenerated stub


        $this->lang=cookie('think_lang');
        $this->conflist=$this->getConf();
        $this->iscache=$this->conflist['iscache'];

        $this->checkweb($this->conflist['state']);
        $this->click= $this->conflist['click'];

        if(isset($this->iscache) && $this->iscache=='1') {

            $page = input('page');
            $cid = input('cid');
            $aid = input('aid');
            if (isset($aid)){
                Db::name('archives')->where('id',$aid)->inc('click',$this->click)->update();//点击
            }
            if (isset($cid)){
                Db::name('click')->insert(['cid'=>$cid,'time'=>time(),'operate_ip'=>Request::ip()]);
            }

            $this->Htmlbul($cid, $aid, $page,$this->iscache);
        }

        $this->Conf=Config::get('view.view_dir_name');//获取模板路径
        $links= $this->links();

        $prosRes=Db::name('archives')->alias('a')
            ->join('pics b','a.id=b.aid')->where('a.status',1)->order('a.click desc')->group('a.id')->field('a.*,b.pic')->limit(10)->select();

        View::assign([
            'cateRes'=>$this->getCate(false),//前端导航和底部导航
            'botCateRes'=>$this->getCate(true),//底部导航和底部导航
            'confs'=>$this->getConf(),//获取网站配置
            'head'=>app()->getRootPath().Config::get('view.view_dir_name'),
            'uid'=>Cookie('uid'),
            'code'=>Cookie('code'),
            'links'=>$links,
            'prosRes'=>$prosRes,
        ]);
    }
    //静态页生成
    protected function Htmlbul($cid,$aid,$page,$iscache){

        if (request()->controller()=='Index'){
            Db::name('click')->insert(['cid'=>1,'time'=>time(),'operate_ip'=>Request::ip()]);
            //检测是否生成静态页
            $url=app()->getRootPath()."runtime/".$this->lang."/index/index.html";
            $temp = Catemodel::cacheAdd($url,$iscache);
        }
        if (request()->controller()=='Page'){

            $url = app()->getRootPath()  . "runtime/".$this->lang."/pages/" . $cid . '.html';//获取当前栏目静态页面
            $temp = Catemodel::cacheAdd($url,$iscache);
        }
        if (request()->controller()=='Cate'){

            if ($page) {

                $url = app()->getRootPath() . "runtime/".$this->lang."/html_id/" . $cid .'_'.$page. '.html';

            } else {

                $url = app()->getRootPath() . "runtime/".$this->lang."/html/" . $cid . '.html';
            }
     
            $temp = Catemodel::cacheAdd($url,$iscache);

        }

        if (request()->controller()=='Article'){

            $url = app()->getRootPath() . "runtime/".$this->lang."/article/" . $aid . '.html';
            
            $temp = Catemodel::cacheAdd($url,$iscache);

        }

    }
//前端导航和底部导航
    public function getCate($bottom=false){
        if($bottom){//底部导航
            $cateRes=Db::name('arc_cate')->order('sort DESC')->where(array('pid'=>0,'status'=>1,'bottom_nav'=>1))->select()->all();
        }else{//顶部导航
            $cateRes=Db::name('arc_cate')->order('sort DESC')->where(array('pid'=>0,'status'=>1))->select()->all();
        }
        foreach ($cateRes as $k => $v) {
            $cateRes[$k]['children']=Db::name('arc_cate')->where(array('pid'=>$v['id'],'status'=>1))->select()->all();
        }
        return $cateRes;
    }
    //获取网站配置
    public static function getConf(){
        $confRes= Db::name('conf')->find(1);
        $conf=json_decode($confRes['web'],true);;
        $img=explode(',',$conf['img']);

        if (count($img)<=1){
            $conf['img']=$img[0];
        }else{
            $conf['img']=$img;
        }

        $ewm=explode(',',$conf['ewm']);
        if (count($ewm)<=1){
            $conf['ewm']=$ewm[0];
        }else{
            $conf['ewm']=$ewm;
        }

        return $conf;
    }
    //判断网站是否开启
    private function checkweb($state){

        if ($state=='0'){
            header('Content-Type:text/html;charset=utf-8');
            echo ' <div style=" text-align: center;font-size: 4rem;width: 100%; color: #f00; padding: 10% 0;">网站正在维护中....</div>';
            exit;
        }
    }
    public function links(){
        $links=Db::name('links')->order('id desc')->where('status','=',1)->where('webstatus','=',0)->select();
        return $links;
    }


    public function modelfields($id){

        $diyFields=Db::name('model')->field('table_name')->find($id);

       return Db::name($diyFields['table_name'])->paginate(15);
    }


}