<?php
/**
 * Created by PhpStorm.
 * User: pc
 * Date: 2021/4/27
 * Time: 15:13
 */

namespace app\template\controller;
use think\facade\Db;
use think\facade\View;
use app\template\model\Cate;
use think\facade\Request;
class Page extends Common
{
    public function index($cid)
    {
        $cates = Db::name('arc_cate')->find($cid);//查询当前栏目信息
        //判断指定栏目的跳转
        if (!$cates){
            redirect('/')->send();
            return;
        }
        //判断带有/index.php跳转
        if(strpos(request()->url(),'/index.php') !== false){
            $index = str_replace("/index.php","",request()->url());
            return redirect($index);
        }

        //判断指定栏目的跳转
        if (!$cates['jump_id']==0){
            $cid=$cates['jump_id'];
            $cates= Db::name('arc_cate')->find($cid);//查询跳转栏目信息
        }
        //添加点击数
        Db::name('click')->insert(['cid'=>$cid,'time'=>time(),'operate_ip'=>Request::ip()]);
        $cateTmp=$cates['index_tmp'];
        $tempSrc=$this->Conf.'/'.$cateTmp;//路径

        //获取顶级栏目id
        $topcid=(new Cate())->getTopId($cid);
        //顶级栏目信息
        $topCates=Db::name('arc_cate')->find($topcid);//顶级栏目信息
        //根据主栏目id获取当前主栏目下所有二级栏目
        $sonCateRes=Db::name('arc_cate')->where(array('pid'=>$topcid))->where(array('status'=>1))->select();

        /*多图拆分*/
        $imgres=explode(',',$topCates['img']);
        $img=[];
        if (count($imgres)>1){
            foreach ($imgres as $v){
                $img[]['img']= $v;
            }
            $topCates['img']=$img;
        }

        if (count($sonCateRes)<1){
            $sonCateRes=Db::name('arc_cate')->where('id','in',array(1,2,3,4))->where(array('status'=>1))->select();
        }

        //当前位置
        $pos=(new Cate())->position($cid);

        //随机生成文章
       $pros=(new Cate())->pros(8);



        View::assign([
            'cates'=>$cates,
            "sonCateRes"=>$sonCateRes, //根据主栏目id获取当前主栏目下所有二级栏目
            "topCates"=>$topCates,//顶级栏目信息
            "sonCateRes"=>$sonCateRes,//更具主栏目ID获取子栏目id
            'pos'=>$pos,//当前位置
            'cid'=>$cid,
            'pros'=>$pros,
            'topcid'=>$topcid
        ]);
        //判断静态页面不存在生成静态页面
        if(isset($this->iscache) && $this->iscache=='1'){
            $this->buildHtml($cid, app()->getRootPath() . "runtime/".$this->lang."/pages/", $tempSrc);
           // $tempSrc = app()->getRootPath() . "runtime/pages/" . $cid . '.html';
        }

        return  View::fetch($tempSrc);

    }
}