var cols_arr=[[
    {type: 'checkbox', width: 60}
    ,{field: 'id', width: 60, title: 'ID', sort: true,align: 'center'}
    , {field: 'title', title: '文章标题',toolbar:'#title', minWidth: 200}
    , {field: 'cate_name', title: '所属栏目',align: 'center',width: 120}
    , {field: 'click', title: '阅读次数',align: 'center',width: 80,edit: 'text'}
    , {field: 'attr', title: '类型',align: 'center',width: 80}
    , {field: 'status', title: '状态',width: 80,align: 'center',toolbar:'#status' }
    , {field: 'time',  title: '发布时间',width: 120,align: 'center',edit: 'text'}
    , {field: 'attr_time',  title: '置顶',width: 90,align: 'center',toolbar:'#attr_time'}
    , {field: 'cz', width: 120, title: '操作', toolbar: '#barDemo', align: 'center', fixed: 'right'}
]];
var response={
    statusName: 'status' //规定数据状态的字段名称，默认：code
    , statusCode: 200 //规定成功的状态码，默认：0
    , msgName: 'hint' //规定状态信息的字段名称，默认：msg
    , countName: 'total' //规定数据总数的字段名称，默认：count
    , dataName: 'rows' //规定数据列表的字段名称，默认：data
};
layui.use(['layer', 'form', 'table','laydate','util','dropdown'], function () {
    var dropdown = layui.dropdown;
    var layer = layui.layer;
    var util = layui.util;
    var form = layui.form;
    var table = layui.table;
    var laydate = layui.laydate;



    //查询日期范围
    laydate.render({
        elem: '#time'
        //设置开始日期、日期日期的 input 选择器
        //数组格式为 2.6.6 开始新增，之前版本直接配置 true 或任意分割字符即可
        ,range: ['#test-startDate-1', '#test-endDate-1']
    });

    //监听单元格编辑
    laydate.render({
        elem: '#test6'
        ,range: true

    });

    //修改访问次数

    //监听指定开关
    form.on('checkbox(switchOpen)', function(data){
      if (this.checked){
          //layui-btn-disabled
          $("#getStatus").removeClass("layui-btn-disabled")
          $("#getDel").removeClass("layui-btn-disabled")
      }else {
          $("#getStatus").addClass("layui-btn-disabled")
          $("#getDel").addClass("layui-btn-disabled")
      }
    });

    table.on('toolbar(demo)', function(obj){
        var checkStatus = table.checkStatus(obj.config.id);
        switch(obj.event){
            case 'getStatus':

                var data = checkStatus.data;
                var arrId = new Array();
                for ( var i in data) {
                    arrId[i] = data[i].id;// 得到复选框的值
                }


                var id=JSON.stringify(arrId);

                layer.confirm('确定要发布吗？',function(index){
                    //发异步删除数据
                    $.post("/Archives/status",{id:id},function (res) {
                        location.reload();
                    },'json').error(function (err) {
                        layer.msg(err['responseJSON']['message'],function () {
                            location.reload();
                        });
                    });
                });

                break;
            case 'getDel':

                var data = checkStatus.data;
                var arrId = new Array();
                for ( var i in data) {
                    arrId[i] = data[i].id;// 得到复选框的值
                }
                var id=JSON.stringify(arrId);

                layer.confirm('确认要删除吗？',function(index){
                    //发异步删除数据
                    $.post("/Archives/del",{cateid:id},function (res) {

                        layer.msg(res.msg,{time:1000},function () {
                            location.reload();
                        })
                    },'json').error(function (err) {
                        layer.msg(err['responseJSON']['message'],function () {
                            location.reload();
                        });
                    });
                });
                break;
            case 'isAll':
                layer.msg(checkStatus.isAll ? '全选': '未全选');
                break;

            //自定义头工具栏右侧图标 - 提示
            case 'LAYTABLE_TIPS':
                layer.alert('这是工具栏右侧自定义的一个图标按钮');
                break;
        };
    });
    // 排序
    table.on('edit(demo)', function(obj){
        var value = obj.value //得到修改后的值
            ,data = obj.data //得到所在行所有键值
            ,field = obj.field; //得到字段

        var setsortdata={id:data.id,click:util.escape(value),name:field};
        $.ajaxDirect("/Archives/edit",'post', setsortdata, function(res){
            if (res.code==1) {
                layer.msg(res.msg);
            }else{
                layer.msg(res.msg);
            }
        });

    });

    //触发事件
    table.render({
        elem: '#demo'
        , page: true //开启分页
        , limit: 10
        , limits: [10, 20, 40, 60, 80, 100,200]
        , url: '/Archives/lstselect'
        ,toolbar: '#toolbarDemo'
        ,defaultToolbar: ['filter', 'exports', 'print']
        , cols: cols_arr
        , response: response
        ,done: function(){
            //初演示
            dropdown.render({
                elem: '#reloadTest'
                ,data: [{
                    title: '图文'
                    ,url: '/Archives/add?attr=0'
                },{
                    title: '图片集'
                    ,url: '/Archives/add?attr=1'
                },{
                    title: '视频集'
                    ,url: '/Archives/add?attr=3'
                },{
                    title: '外部链接'
                    ,url: '/Archives/add?attr=2'
                },{
                    title: '资源下载'
                    ,url: '/Archives/add?attr=4'
                }]
                ,click: function(obj){
                    abutton(obj.title+'编辑',obj.url)
                   // $(location).attr("href",obj.url)

                }
            });

        }
    });


    //搜索
    form.on('submit(demo1)',
        function (data) {
            var data=data.field;

            table.render({
                elem: '#demo'
                ,method: 'post'
                , page: true //开启分页
                , limit: 10
                ,where:data
                ,toolbar: '#toolbarDemo' //开启头部工具栏，并为其绑定左侧模板
                ,defaultToolbar: ['filter', 'exports', 'print',]
                , limits: [10, 20, 40, 60, 80, 100,200]
               // , url: '/Archives/lstselect/?cate_id='+cate_id+'&title='+title
                 ,url:'/Archives/lstselect'
                , cols: cols_arr
                , response:response
            });
            return;
        });
    //行工具事件

});
/*添加*/
function admin_add(title,url,w,h){
    x_admin_show(title,url,w,h);
};
// 编辑
function banner_edit (title,url,id,w,h) {
    x_admin_show(title,url,w,h);
};
function member_del(obj,id){
    layer.confirm('确认要删除吗？',function(index){
        //发异步删除数据
        $.post("/Archives/del",{cateid:id},function (res) {
            layer.msg(res.msg,{time:1000},function () {
                if (res.code==1) {
                    $(obj).parents("tr").remove();
                }
            })
        },'json').error(function (err) {
            layer.msg(err['responseJSON']['message'],function () {
                location.reload();
            });
        });
    });
};

function status(o,id){
    $.post("/Archives/status",{id:id},function (res) {
        if(res.code==1){

                layer.msg(res.msg,{time:1000},function () {
                    location.reload();
                })

        }else {
            layer.msg(res.msg);
        }
    },'json').error(function (err) {
        layer.msg(err['responseJSON']['message'],function () {
            location.reload();
        });
    });
};
function attr_time(o,id){
    $.post("/Archives/attr_time",{id:id},function (res) {
        if(res.code==1){
            if (res.msg=="置顶"){

                $(o).removeClass("layui-bg-green")
                $(o).addClass("layui-bg-red")
            }else {

                $(o).removeClass("layui-bg-red")
                $(o).addClass("layui-bg-green")
            }
            $(o).text(res.msg)

        }else {
            layer.msg(res.msg);
        }
    },'json').error(function (err) {
        layer.msg(err['responseJSON']['message'],function () {
            location.reload();
        });
    });
};


$.ajaxDirect("/Archives/cate",'post','', function(data){
    var xmSelect = layui.xmSelect;
    //渲染多选
    var demo1 = xmSelect.render({
        autoRow: true,
        tree: {
            show: true,
            showFolderIcon: true,
            showLine: true,
            indent: 20,
            expandedKeys: [-1],

        },
        el: '#demo1',
        height: 'auto',
        data: data.data
    })

    layui.form.render("select");
});
